SystemOrganization addCategory: #CSA!
SystemOrganization addCategory: #'CSA-Events'!
SystemOrganization addCategory: #'CSA-Metrics'!
SystemOrganization addCategory: #'CSA-UI'!
SystemOrganization addCategory: #'CSA-Test'!

Trait named: #TCSAEventHandler
	uses: {}
	category: 'CSA-Events'!

!TCSAEventHandler methodsFor: 'class events' stamp: 'sk 12/16/2011 21:41:00.595'!
addedClass: aCSAClassAddedEvent
	^ self doDefaultHandlingFor: aCSAClassAddedEvent! !

!TCSAEventHandler methodsFor: 'method events' stamp: 'sk 12/16/2011 23:28:43.042'!
addedMethod: aCSAMethodAddedEvent
	^ self doDefaultHandlingFor: aCSAMethodAddedEvent! !

!TCSAEventHandler methodsFor: 'class events' stamp: 'sk 1/6/2012 19:43:39.096'!
commentedClass: aCSAClassCommentedEvent
	^ self doDefaultHandlingFor: aCSAClassCommentedEvent   ! !

!TCSAEventHandler methodsFor: 'general handling' stamp: 'sk 12/16/2011 21:40:23.582'!
doDefaultHandlingFor: aCSAEvent
	self requirement! !

!TCSAEventHandler methodsFor: 'general handling' stamp: 'sk 12/16/2011 23:41:19.443'!
handle: aCSAEvent
	^ aCSAEvent accept: self! !

!TCSAEventHandler methodsFor: 'class events' stamp: 'sk 12/17/2011 15:58:42.746'!
modifiedClass: aCSAClassModifiedEvent
	^ self doDefaultHandlingFor: aCSAClassModifiedEvent  ! !

!TCSAEventHandler methodsFor: 'method events' stamp: 'sk 12/17/2011 00:03:19.198'!
modifiedMethod: aCSAMethodChangedEvent
	^ self doDefaultHandlingFor: aCSAMethodChangedEvent  ! !

!TCSAEventHandler methodsFor: 'class events' stamp: 'sk 12/17/2011 16:09:42.133'!
recategorizedClass: aCSAClassRecategorizedEvent
	^ self doDefaultHandlingFor: aCSAClassRecategorizedEvent  ! !

!TCSAEventHandler methodsFor: 'method events' stamp: 'sk 1/6/2012 20:14:43.448'!
recategorizedMethod: aCSAMethodRecategorizedEvent
	^ self doDefaultHandlingFor: aCSAMethodRecategorizedEvent  ! !

!TCSAEventHandler methodsFor: 'class events' stamp: 'sk 12/16/2011 21:42:15.194'!
removedClass: aCSAClassRemovedEvent
	^ self doDefaultHandlingFor: aCSAClassRemovedEvent   ! !

!TCSAEventHandler methodsFor: 'method events' stamp: 'sk 12/16/2011 23:42:31.492'!
removedMethod: aCSAMethodRemovedEvent
	^ self doDefaultHandlingFor: aCSAMethodRemovedEvent  ! !

!TCSAEventHandler methodsFor: 'class events' stamp: 'sk 12/16/2011 23:39:00.133'!
renamedClass: aCSAClassRenamedEvent
	^ self doDefaultHandlingFor: aCSAClassRenamedEvent   ! !

Morph subclass: #CSATable
	instanceVariableNames: 'metricColumns'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-UI'!

!CSATable class methodsFor: 'magic numbers' stamp: 'f.z 1/9/2012 16:04:26.52'!
cellInset
	^ 3! !

!CSATable class methodsFor: 'magic numbers' stamp: 'f.z 1/9/2012 16:04:18.121'!
layoutProperties
	^ (TableLayoutProperties new)
		cellPositioning: #topLeft;
		cellInset: self cellInset;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		listCentering: #topLeft;
		listDirection: #leftToRight;
		yourself          ! !

!CSATable methodsFor: 'column management' stamp: 'f.z 1/9/2012 18:00:40.457'!
addColumnFor: aMetric
	self metricColumns at: aMetric class put: (self createColumnFor: aMetric).
	self addMorph: (self metricColumns at: aMetric class).
	aMetric when: #valueChanged send: #updateColumnFor: to: self! !

!CSATable methodsFor: 'column management' stamp: 'f.z 1/9/2012 17:49:42.057'!
createColumnFor: aMetric
	^ (CSATextWindow labelled: aMetric columnTitle withColor: Color transparent)
		text: aMetric columnContents asString;
		yourself! !

!CSATable methodsFor: 'initialization' stamp: 'f.z 1/9/2012 15:56:44.809'!
initialize
	super initialize.
	self
		metricColumns: Dictionary new;
		layoutPolicy: TableLayout new;
		layoutProperties: self class layoutProperties! !

!CSATable methodsFor: 'accessing' stamp: 'f.z 1/9/2012 15:56:25.458'!
metricColumns
	^ metricColumns! !

!CSATable methodsFor: 'accessing' stamp: 'f.z 1/9/2012 15:56:25.487'!
metricColumns: aDictionary
	metricColumns := aDictionary
! !

!CSATable methodsFor: 'initialization' stamp: 'f.z 1/9/2012 15:39:13.04'!
postAddInitialize
	self 
		color: Color transparent;
		borderColor: Color transparent  ! !

!CSATable methodsFor: 'column management' stamp: 'f.z 1/9/2012 18:02:50.298'!
removeColumnFor: aMetricClass
	aMetricClass allInstancesDo: [ :metric | metric removeActionsWithReceiver: self ].
	self removeMorph: (self metricColumns at: aMetricClass)  ! !

!CSATable methodsFor: 'column management' stamp: 'f.z 1/9/2012 17:55:13.337'!
tryToRemoveColumnFor: aMetric
	| column |
	column := self metricColumns removeKey: [ aMetric ] ifAbsent: [ ^ self ].
	column removeActionsWithReceiver: self.  
	self removeMorph: column  ! !

!CSATable methodsFor: 'column management' stamp: 'f.z 1/9/2012 17:49:54.969'!
updateColumnFor: aMetric
	(self metricColumns at: aMetric) text: aMetric columnContents asString! !

TestCase subclass: #CSASingleClassSourceTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Test'!

!CSASingleClassSourceTest methodsFor: 'as yet unclassified' stamp: 'f.z 1/5/2012 12:46:32.624'!
testGetClasses
	| classes |
	classes := (CSASingleClassSource for: String) allClasses.
	self assert: classes size == 1.
	self assert: (classes includes: String).! !

BorderedMorph subclass: #CSAMetricWindow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-UI'!

!CSAMetricWindow class methodsFor: 'constants' stamp: 'sk 12/21/2011 21:15:18.868'!
extent
	^ 150 @ 100! !

!CSAMetricWindow class methodsFor: 'instance creation' stamp: 'f.z 1/9/2012 17:43:47.289'!
labelled: aString withColor: aColor  
	^ self new
		"setLabel: aString;"
		"paneColor: aColor;"
		color: aColor;
		borderColor: aColor muchDarker;  
		yourself! !

!CSAMetricWindow methodsFor: 'initialize-release' stamp: 'sk 12/21/2011 19:33:24.222'!
createWidgets
	self subclassResponsibility! !

!CSAMetricWindow methodsFor: 'initialize-release' stamp: 'sk 12/22/2011 15:03:56.74'!
initialize
	super initialize.
	self
		initializeLayout;
		createWidgets    ! !

!CSAMetricWindow methodsFor: 'initialize-release' stamp: 'sk 12/22/2011 15:59:00.487'!
initializeLayout
	self
		layoutPolicy: TableLayout new; 
		layoutProperties:
			(TableLayoutProperties new
				hResizing: #shrinkWrap;
				vResizing: #shrinkWrap;
				layoutInset: 2;
				yourself)! !

!CSAMetricWindow methodsFor: 'initialize-release' stamp: 'sk 12/22/2011 13:30:22.901'!
openInWorld
	super openInWorld.
	self extent: self class extent.! !

!CSAMetricWindow methodsFor: 'initialize-release' stamp: 'sk 12/22/2011 15:00:15.746'!
wantsRoundedCorners
	^ true! !

CSAMetricWindow subclass: #CSATextWindow
	instanceVariableNames: 'textMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-UI'!

!CSATextWindow methodsFor: 'as yet unclassified' stamp: 'sk 12/22/2011 16:06:54.63'!
createWidgets
	self
		textMorph: (TextMorph new 
			backgroundColor: (Color black alpha: 0);
			textColor: Color white;
			yourself);
		addMorph: self textMorph! !

!CSATextWindow methodsFor: 'as yet unclassified' stamp: 'sk 12/21/2011 20:56:47.718'!
text: aStringOrText
	self textMorph contents: aStringOrText! !

!CSATextWindow methodsFor: 'accessing' stamp: 'sk 12/21/2011 20:52:28.571'!
textMorph
	^ textMorph! !

!CSATextWindow methodsFor: 'accessing' stamp: 'sk 12/21/2011 20:52:28.607'!
textMorph: aTextMorph
	textMorph := aTextMorph
! !

SystemWindow subclass: #CSAWidget
	instanceVariableNames: 'dispatcher menuBar metrics table'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-UI'!

!CSAWidget class methodsFor: 'magic numbers' stamp: 'f.z 1/9/2012 18:05:15.225'!
baseLabel
	^ 'CSA Widget'! !

!CSAWidget class methodsFor: 'magic numbers' stamp: 'f.z 1/9/2012 18:05:25.577'!
initialLabel
	^ self baseLabel, ' <<no class source>>'! !

!CSAWidget class methodsFor: 'instance creation' stamp: 'f.z 1/9/2012 18:04:47.593'!
start
	^ (self labelled: self initialLabel)
		openInWorld;
		yourself! !

!CSAWidget methodsFor: 'initialization' stamp: 'f.z 1/9/2012 12:48:44.17'!
addMenuEntries
	self menuBar 
		add: 'File' subMenu: self createFileMenu;
		add: 'Columns' subMenu: self createColumnsMenu! !

!CSAWidget methodsFor: 'updating' stamp: 'f.z 1/9/2012 17:48:29.161'!
addMetric: aMetricClass
	| metric |
	metric := self dispatcher addMetric: aMetricClass.
	self metrics add: metric.
	self table addColumnFor: metric! !

!CSAWidget methodsFor: 'setup' stamp: 'f.z 1/9/2012 18:06:58.41'!
classSourceFrom: aWildcardString
	aWildcardString ifNil: [ ^ self ].
	self
		setLabel: self class baseLabel, ' for ', aWildcardString;
		removeDispatcher;
		setupDispatcherWith: (CSACategoryClassSource for: aWildcardString)! !

!CSAWidget methodsFor: 'initialization' stamp: 'f.z 1/9/2012 12:47:38.949'!
createColumnsMenu
	| menu |
	menu := DockingBarMenuMorph new.
	self displayableMetrics do: 
		[ :metric | menu add: metric name target: self selector: #toggleColumnFor: argument: metric ].
	^ menu! !

!CSAWidget methodsFor: 'initialization' stamp: 'f.z 1/9/2012 12:52:33.522'!
createFileMenu
	^ (DockingBarMenuMorph new)
		add: 'Set Class Source' target: self selector: #promptForClassSource;
		addLine;
		add: 'Close' target: self selector: #closeBoxHit;
		yourself! !

!CSAWidget methodsFor: 'open/close' stamp: 'f.z 1/9/2012 13:15:08.457'!
delete
	super delete.
	self dispatcher dismiss! !

!CSAWidget methodsFor: 'accessing' stamp: 'f.z 1/9/2012 12:57:00.969'!
dispatcher
	^ dispatcher! !

!CSAWidget methodsFor: 'accessing' stamp: 'f.z 1/9/2012 12:57:00.986'!
dispatcher: anEventDispatcher
	dispatcher := anEventDispatcher
! !

!CSAWidget methodsFor: 'accessing' stamp: 'f.z 1/9/2012 12:36:40.865'!
displayableMetrics
	"Answers all Subclasses of CSAMetric that do not have additional subclasses. "
	^ CSAMetric allSubclasses select: [ :subClass | subClass allSubclasses isEmpty ]! !

!CSAWidget methodsFor: 'initialization' stamp: 'f.z 1/9/2012 15:32:10.928'!
initialize
	super initialize.
	self 
		initializeMembers;
		setupMenuBar;
		setupMetricTable! !

!CSAWidget methodsFor: 'initialization' stamp: 'f.z 1/9/2012 15:30:38.799'!
initializeMembers
	self 
		dispatcher: CSANullEventDispatcher new;
		metrics: OrderedCollection new;
		menuBar: DockingBarMorph new;
		table: CSATable new! !

!CSAWidget methodsFor: 'accessing' stamp: 'f.z 1/9/2012 12:21:17.202'!
menuBar
	^ menuBar! !

!CSAWidget methodsFor: 'accessing' stamp: 'f.z 1/9/2012 12:21:17.219'!
menuBar: aDockingBarMorph
	menuBar := aDockingBarMorph
! !

!CSAWidget methodsFor: 'layout' stamp: 'f.z 1/9/2012 12:23:04.306'!
menuBarFrame
	^ LayoutFrame 
		fractions: (0@0 corner: 1@0)
		offsets: (0@0 corner: 0@20)! !

!CSAWidget methodsFor: 'accessing' stamp: 'f.z 1/9/2012 13:06:51.201'!
metrics
	^ metrics! !

!CSAWidget methodsFor: 'accessing' stamp: 'f.z 1/9/2012 13:06:51.213'!
metrics: aCollection
	metrics := aCollection
! !

!CSAWidget methodsFor: 'setup' stamp: 'f.z 1/9/2012 12:55:59.498'!
promptForClassSource
	self classSourceFrom: (SwaInputDialog getTextWithTitle: 'Package Filter' label: '')! !

!CSAWidget methodsFor: 'setup' stamp: 'f.z 1/9/2012 13:15:41.618'!
removeDispatcher
	self dispatcher dismiss.
	self dispatcher: CSANullEventDispatcher new! !

!CSAWidget methodsFor: 'updating' stamp: 'f.z 1/9/2012 18:01:02.003'!
removeMetric: aMetricClass
	self metrics: (self metrics reject: [ :metric | metric class = aMetricClass ]).
	self dispatcher removeMetric: aMetricClass.
	self table removeColumnFor: aMetricClass! !

!CSAWidget methodsFor: 'setup' stamp: 'f.z 1/9/2012 13:08:17.476'!
setupDispatcherWith: aClassSource
	self dispatcher: (CSAEventDispatcher for: aClassSource).
	self metrics do: [ :metric | self dispatcher addMetric: metric ]! !

!CSAWidget methodsFor: 'initialization' stamp: 'f.z 1/9/2012 15:31:56.4'!
setupMenuBar
	self
		addMorph: self menuBar fullFrame: self menuBarFrame;
		addMenuEntries! !

!CSAWidget methodsFor: 'initialization' stamp: 'f.z 1/9/2012 15:38:39.905'!
setupMetricTable
	self addMorph: self table fullFrame: self tableFrame.
	self table postAddInitialize! !

!CSAWidget methodsFor: 'accessing' stamp: 'f.z 1/9/2012 15:30:26.385'!
table
	^ table! !

!CSAWidget methodsFor: 'accessing' stamp: 'f.z 1/9/2012 15:30:26.407'!
table: aTable
	table := aTable
! !

!CSAWidget methodsFor: 'layout' stamp: 'f.z 1/9/2012 15:28:28.322'!
tableFrame
	^ LayoutFrame 
		fractions: (0@0 corner: 1@1)
		offsets: (0@20 corner: 0@0)! !

!CSAWidget methodsFor: 'updating' stamp: 'f.z 1/9/2012 16:06:52.217'!
toggleColumnFor: aMetricClass
	(self metrics anySatisfy: [ :metric | metric class = aMetricClass ])
		ifTrue: [ self removeMetric: aMetricClass ]
		ifFalse: [ self addMetric: aMetricClass ]! !

Object subclass: #CSAClassSource
	uses: TCSAEventHandler @ {#adjust:->#handle:}
	instanceVariableNames: 'classes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA'!

CSAClassSource class
	uses: TCSAEventHandler classTrait
	instanceVariableNames: ''!

CSAClassSource subclass: #CSACategoryClassSource
	instanceVariableNames: 'wildcard'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA'!

!CSACategoryClassSource class methodsFor: 'instance creation' stamp: 'sk 12/5/2011 12:03:00.362'!
for: aString
	^ self new
		wildcard: aString;
		yourself  ! !

!CSACategoryClassSource methodsFor: 'accessing' stamp: 'sk 12/17/2011 19:20:16.006'!
contains: aClass
	^ self containsCategory: aClass theNonMetaClass category  ! !

!CSACategoryClassSource methodsFor: 'accessing' stamp: 'sk 12/22/2011 22:00:58.66'!
containsCategory: aSymbol
	^ aSymbol
		ifNil: [ false ]
		ifNotNil: [ self wildcard match: aSymbol ]  ! !

!CSACategoryClassSource methodsFor: 'class events' stamp: 'sk 12/17/2011 19:31:21.333'!
recategorizedClass: aCSAClassRecategorizedEvent
	| isContained wasContained |
	isContained := self containsCategory: aCSAClassRecategorizedEvent newCategory.
	wasContained := self containsCategory: aCSAClassRecategorizedEvent oldCategory.
	(isContained & wasContained) ifTrue:
		[ ^ aCSAClassRecategorizedEvent ] .
	(isContained & wasContained not) ifTrue:
		[ ^ CSAClassAddedEvent for: aCSAClassRecategorizedEvent movedClass].
	(isContained not & wasContained) ifTrue:   
		[ ^ CSAClassRemovedEvent for: aCSAClassRecategorizedEvent movedClass].
	^ nil! !

!CSACategoryClassSource methodsFor: 'class events' stamp: 'sk 1/6/2012 22:07:41.401'!
renamedClass: aCSAClassRecategorizedEvent
	^ (self contains: aCSAClassRecategorizedEvent renamedClass)
		ifTrue: [ aCSAClassRecategorizedEvent ]
		ifFalse: [ nil ]    ! !

!CSACategoryClassSource methodsFor: 'accessing' stamp: 'sk 12/5/2011 11:59:27.41'!
wildcard
	^ wildcard! !

!CSACategoryClassSource methodsFor: 'accessing' stamp: 'sk 12/5/2011 11:59:27.438'!
wildcard: aString
	wildcard := aString
! !

!CSAClassSource methodsFor: 'class events' stamp: 'sk 12/17/2011 19:27:44.316'!
addedClass: aCSAClassAddedEvent
	^ (self contains: aCSAClassAddedEvent newClass)
		ifTrue: [ aCSAClassAddedEvent ]
		ifFalse: [ nil ]    ! !

!CSAClassSource methodsFor: 'method events' stamp: 'sk 12/17/2011 19:28:30.432'!
addedMethod: aCSAMethodAddedEvent
	^ (self contains: aCSAMethodAddedEvent method methodClass)
		ifTrue: [ aCSAMethodAddedEvent ]
		ifFalse: [ nil ]    ! !

!CSAClassSource methodsFor: 'accessing' stamp: 'f.z 1/5/2012 12:47:41.023'!
allClasses
	^ self classes flatCollect: [ :nonMetaClass | self allClassesFor: nonMetaClass ]! !

!CSAClassSource methodsFor: 'accessing' stamp: 'f.z 1/5/2012 12:48:31.007'!
allClassesFor: aNonMetaClass
	^ OrderedCollection with: aNonMetaClass with: aNonMetaClass class! !

!CSAClassSource methodsFor: 'accessing' stamp: 'f.z 1/5/2012 12:52:30.929'!
classes
	^ (Smalltalk allClasses select: [ :class | self contains: class ]) asOrderedCollection! !

!CSAClassSource methodsFor: 'class events' stamp: 'sk 1/6/2012 23:22:49.118'!
commentedClass: aCSAClassCommentedEvent
	^ (self contains: aCSAClassCommentedEvent commentedClass)
		ifTrue: [ aCSAClassCommentedEvent ]
		ifFalse: [ nil ]    ! !

!CSAClassSource methodsFor: 'accessing' stamp: 'sk 12/6/2011 01:46:20.115'!
contains: aClass
"Tells whether this class source contains the given class."
	self subclassResponsibility! !

!CSAClassSource methodsFor: 'general handling' stamp: 'sk 1/6/2012 23:22:01.116'!
doDefaultHandlingFor: aCSAEvent
	^ nil! !

!CSAClassSource methodsFor: 'class events' stamp: 'sk 1/6/2012 23:27:08.12'!
modifiedClass: aCSAClassModifiedEvent
	^ (self contains: aCSAClassModifiedEvent newClass)
		ifTrue: [ aCSAClassModifiedEvent ]
		ifFalse: [ nil ]! !

!CSAClassSource methodsFor: 'method events' stamp: 'sk 12/17/2011 19:28:10.818'!
modifiedMethod: aCSAMethodChangedEvent
	^ (self contains: aCSAMethodChangedEvent method methodClass)
		ifTrue: [ aCSAMethodChangedEvent ]
		ifFalse: [ nil ]    ! !

!CSAClassSource methodsFor: 'method events' stamp: 'sk 1/6/2012 23:24:08.725'!
recategorizedMethod: aCSAMethodRecategorizedEvent
	^ (self contains: aCSAMethodRecategorizedEvent method methodClass)
		ifTrue: [ aCSAMethodRecategorizedEvent ]
		ifFalse: [ nil ]! !

!CSAClassSource methodsFor: 'class events' stamp: 'sk 12/17/2011 19:27:52.812'!
removedClass: aCSAClassRemovedEvent
	^ (self contains: aCSAClassRemovedEvent removedClass)
		ifTrue: [ aCSAClassRemovedEvent ]
		ifFalse: [ nil ]    ! !

!CSAClassSource methodsFor: 'method events' stamp: 'sk 12/17/2011 19:28:20.197'!
removedMethod: aCSAMethodRemovedEvent
	^ (self contains: aCSAMethodRemovedEvent method methodClass)
		ifTrue: [ aCSAMethodRemovedEvent ]
		ifFalse: [ nil ]    ! !

CSAClassSource subclass: #CSAEmptyClassSource
	uses: TCSAEventHandler @ {#adjust:->#handle:}
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA'!

CSAEmptyClassSource class
	uses: TCSAEventHandler classTrait
	instanceVariableNames: ''!

!CSAEmptyClassSource methodsFor: 'accessing' stamp: 'f.z 1/9/2012 13:03:18.354'!
contains: aClass
	^ false! !

CSAClassSource subclass: #CSASingleClassSource
	instanceVariableNames: 'containedClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA'!

!CSASingleClassSource class methodsFor: 'instance creation' stamp: 'sk 12/4/2011 23:23:46.152'!
for: aClass
	^ self new
		containedClass: aClass;
		yourself  ! !

!CSASingleClassSource methodsFor: 'accessing' stamp: 'sk 12/4/2011 22:42:31.441'!
containedClass
	^ containedClass! !

!CSASingleClassSource methodsFor: 'accessing' stamp: 'sk 12/4/2011 22:42:52.644'!
containedClass: aClass
	containedClass := aClass.! !

!CSASingleClassSource methodsFor: 'accessing' stamp: 'f.z 1/2/2012 10:21:42.556'!
contains: aClass
	^ aClass = containedClass! !

CSAClassSource subclass: #CSAWildcardClassSource
	instanceVariableNames: 'wildcard'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA'!

!CSAWildcardClassSource class methodsFor: 'instance creation' stamp: 'sk 12/5/2011 00:50:39.949'!
for: aString
	^ (self new)
		wildcard: aString;
		yourself   ! !

!CSAWildcardClassSource methodsFor: 'matching' stamp: 'sk 12/5/2011 13:09:38.033'!
contains: aClass
	^ self wildcard match: aClass asString! !

!CSAWildcardClassSource methodsFor: 'accessing' stamp: 'sk 12/5/2011 00:18:57.184'!
wildcard
	^ wildcard! !

!CSAWildcardClassSource methodsFor: 'accessing' stamp: 'sk 12/5/2011 00:18:57.207'!
wildcard: aString
	wildcard := aString 
! !

Object subclass: #CSAEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Events'!

!CSAEvent commentStamp: 'sk 1/6/2012 19:21:57.405' prior: 0!
I represent any state-change of the system, such as removed methods or renamed classes.
My subclasses are responsible for the concrete changes.
I use double-dispatch: call accept: on me and I will send you a message corresponding to my state-change.
!

CSAEvent subclass: #CSAClassAddedEvent
	instanceVariableNames: 'newClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Events'!

!CSAClassAddedEvent commentStamp: 'sk 1/6/2012 19:47:01.669' prior: 0!
I represent the state change where a class has been added to the system.!

!CSAClassAddedEvent class methodsFor: 'instance creation' stamp: 'sk 12/17/2011 17:55:44.591'!
for: aClass
	^ self new
		newClass: aClass;
		yourself 
	! !

!CSAClassAddedEvent class methodsFor: 'instance creation' stamp: 'sk 12/17/2011 19:24:44.96'!
forSystemEvent: anAddedEvent
	^ self for: anAddedEvent item
	! !

!CSAClassAddedEvent methodsFor: 'visitor' stamp: 'sk 12/17/2011 19:29:30.024'!
accept: aTCSAEventHandler
	^ aTCSAEventHandler addedClass: self! !

!CSAClassAddedEvent methodsFor: 'accessing' stamp: 'sk 12/16/2011 15:25:53.415'!
newClass
	^ newClass! !

!CSAClassAddedEvent methodsFor: 'accessing' stamp: 'sk 12/16/2011 15:25:53.436'!
newClass: aClass
	newClass := aClass
! !

!CSAClassAddedEvent methodsFor: 'printing' stamp: 'sk 1/6/2012 23:11:57.023'!
printEventInformationOn: aStream
	aStream nextPutAll: self newClass asString! !

CSAEvent subclass: #CSAClassCommentedEvent
	instanceVariableNames: 'commentedClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Events'!

!CSAClassCommentedEvent class methodsFor: 'instance creation' stamp: 'sk 1/6/2012 19:42:01.898'!
forSystemEvent: aCommentedEvent
	^ self new
		commentedClass: aCommentedEvent item;
		yourself  
	! !

!CSAClassCommentedEvent methodsFor: 'visitor' stamp: 'sk 1/6/2012 19:51:04.25'!
accept: aTCSAEventHandler
	^ aTCSAEventHandler commentedClass: self! !

!CSAClassCommentedEvent methodsFor: 'accessing' stamp: 'sk 1/6/2012 19:44:45.87'!
commentedClass
	^ commentedClass! !

!CSAClassCommentedEvent methodsFor: 'accessing' stamp: 'sk 1/6/2012 19:44:45.92'!
commentedClass: aClass
	commentedClass := aClass
! !

!CSAClassCommentedEvent methodsFor: 'printing' stamp: 'sk 1/6/2012 19:54:39.403'!
printEventInformationOn: aStream
	aStream nextPutAll: self commentedClass asString! !

CSAEvent subclass: #CSAClassModifiedEvent
	instanceVariableNames: 'newClass oldClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Events'!

!CSAClassModifiedEvent class methodsFor: 'instance creation' stamp: 'sk 12/17/2011 16:00:02.219'!
forSystemEvent: anEvent
	^ self new
		oldClass: anEvent oldItem;
		newClass: anEvent item;
		yourself        ! !

!CSAClassModifiedEvent methodsFor: 'visitor' stamp: 'sk 12/17/2011 15:58:59.26'!
accept: aTCSAEventHandler
	^ aTCSAEventHandler modifiedClass: self! !

!CSAClassModifiedEvent methodsFor: 'accessing' stamp: 'sk 12/17/2011 15:57:28.295'!
newClass
	^ newClass! !

!CSAClassModifiedEvent methodsFor: 'accessing' stamp: 'sk 12/17/2011 15:57:28.376'!
newClass: aClass
	newClass := aClass
! !

!CSAClassModifiedEvent methodsFor: 'accessing' stamp: 'sk 12/17/2011 15:57:28.378'!
oldClass
	^ oldClass! !

!CSAClassModifiedEvent methodsFor: 'accessing' stamp: 'sk 12/17/2011 15:57:28.395'!
oldClass: aClass
	oldClass := aClass
! !

!CSAClassModifiedEvent methodsFor: 'printing' stamp: 'ck 1/5/2012 18:08:49.316'!
printEventInformationOn: aStream
	aStream nextPutAll: self oldClass name, ' -> ', self newClass name! !

CSAEvent subclass: #CSAClassRecategorizedEvent
	instanceVariableNames: 'movedClass oldCategory newCategory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Events'!

!CSAClassRecategorizedEvent commentStamp: 'sk 1/6/2012 19:55:29.701' prior: 0!
I represent the state change where a class has been recategorized.!

!CSAClassRecategorizedEvent class methodsFor: 'instance creation' stamp: 'sk 12/21/2011 22:37:55.545'!
forSystemEvent: aRecategorizedEvent
	^ self new
		oldCategory: aRecategorizedEvent oldCategory;
		newCategory: aRecategorizedEvent itemCategory;
		movedClass: aRecategorizedEvent item;
		yourself  ! !

!CSAClassRecategorizedEvent methodsFor: 'accessing' stamp: 'sk 12/17/2011 16:09:50.735'!
accept: aTCSEventHandler
	^ aTCSEventHandler recategorizedClass: self   ! !

!CSAClassRecategorizedEvent methodsFor: 'accessing' stamp: 'sk 12/17/2011 16:07:50.962'!
movedClass
	^ movedClass! !

!CSAClassRecategorizedEvent methodsFor: 'accessing' stamp: 'sk 12/17/2011 16:07:50.976'!
movedClass: aClass
	movedClass := aClass
! !

!CSAClassRecategorizedEvent methodsFor: 'accessing' stamp: 'sk 12/17/2011 16:07:50.997'!
newCategory
	^ newCategory! !

!CSAClassRecategorizedEvent methodsFor: 'accessing' stamp: 'sk 12/17/2011 16:07:51.002'!
newCategory: aSymbol
	newCategory := aSymbol
! !

!CSAClassRecategorizedEvent methodsFor: 'accessing' stamp: 'sk 12/17/2011 16:07:50.983'!
oldCategory
	^ oldCategory! !

!CSAClassRecategorizedEvent methodsFor: 'accessing' stamp: 'sk 12/17/2011 16:07:50.99'!
oldCategory: aSymbol
	oldCategory := aSymbol
! !

!CSAClassRecategorizedEvent methodsFor: 'printing' stamp: 'sk 1/6/2012 21:43:00.213'!
printEventInformationOn: aStream
	aStream nextPutAll: self movedClass asString, ': ', self oldCategory asString, ' -> ', self newCategory asString! !

CSAEvent subclass: #CSAClassRemovedEvent
	instanceVariableNames: 'removedClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Events'!

!CSAClassRemovedEvent class methodsFor: 'instance creation' stamp: 'sk 12/17/2011 17:53:19.271'!
for: aClass
	^ self new
		removedClass: aClass;
		yourself ! !

!CSAClassRemovedEvent class methodsFor: 'instance creation' stamp: 'sk 12/17/2011 19:41:19.118'!
forSystemEvent: aRemovedEvent
	^ self for: aRemovedEvent item! !

!CSAClassRemovedEvent methodsFor: 'visitor' stamp: 'sk 12/17/2011 19:22:22.471'!
accept: aTCSAEventHandler
	^ aTCSAEventHandler removedClass: self    ! !

!CSAClassRemovedEvent methodsFor: 'printing' stamp: 'sk 1/6/2012 21:43:13.712'!
printEventInformationOn: aStream
	aStream nextPutAll: self removedClass asString! !

!CSAClassRemovedEvent methodsFor: 'accessing' stamp: 'sk 12/16/2011 16:18:14.12'!
removedClass
	^ removedClass! !

!CSAClassRemovedEvent methodsFor: 'accessing' stamp: 'sk 12/16/2011 16:18:14.172'!
removedClass: anObject
	removedClass := anObject! !

CSAEvent subclass: #CSAClassRenamedEvent
	instanceVariableNames: 'renamedClass oldName newName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Events'!

!CSAClassRenamedEvent class methodsFor: 'instance creation' stamp: 'sk 12/17/2011 16:39:37.578'!
forSystemEvent: aRenamedEvent
	^ self new
		oldName: aRenamedEvent oldName;
		newName: aRenamedEvent newName;
		renamedClass: aRenamedEvent item;
		yourself             ! !

!CSAClassRenamedEvent methodsFor: 'visitor' stamp: 'sk 12/17/2011 16:38:20.047'!
accept: aTCSAEventHandler
	^ aTCSAEventHandler renamedClass: self    ! !

!CSAClassRenamedEvent methodsFor: 'accessing' stamp: 'sk 12/17/2011 16:34:11.969'!
newName
	^ newName! !

!CSAClassRenamedEvent methodsFor: 'accessing' stamp: 'sk 12/17/2011 16:34:11.981'!
newName: aSymbol
	newName := aSymbol
! !

!CSAClassRenamedEvent methodsFor: 'accessing' stamp: 'sk 12/17/2011 16:34:11.939'!
oldName
	^ oldName! !

!CSAClassRenamedEvent methodsFor: 'accessing' stamp: 'sk 12/17/2011 16:34:11.954'!
oldName: aSymbol
	oldName := aSymbol
! !

!CSAClassRenamedEvent methodsFor: 'printing' stamp: 'f.z 1/2/2012 11:15:20.955'!
printEventInformationOn: aStream
	aStream nextPutAll: self oldName, ' -> ', self newName! !

!CSAClassRenamedEvent methodsFor: 'accessing' stamp: 'sk 12/17/2011 16:34:11.863'!
renamedClass
	^ renamedClass! !

!CSAClassRenamedEvent methodsFor: 'accessing' stamp: 'sk 12/17/2011 16:34:11.918'!
renamedClass: aClass
	renamedClass := aClass
! !

!CSAEvent methodsFor: 'visitor' stamp: 'sk 12/16/2011 21:39:33.58'!
accept: aTCSAEventHandler
	self subclassResponsibility! !

!CSAEvent methodsFor: 'printing' stamp: 'f.z 1/2/2012 11:10:25.336'!
printEventInformationOn: aStream
	self subclassResponsibility! !

!CSAEvent methodsFor: 'printing' stamp: 'f.z 1/2/2012 11:14:29.179'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: '('.
	self printEventInformationOn: aStream.
	aStream nextPutAll: ')'  ! !

CSAEvent subclass: #CSAMethodEvent
	instanceVariableNames: 'method protocol'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Events'!

CSAMethodEvent subclass: #CSAMethodAddedEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Events'!

!CSAMethodAddedEvent methodsFor: 'visitor' stamp: 'sk 12/16/2011 23:36:42.932'!
accept: aTCSAEventHandler
	^ aTCSAEventHandler addedMethod: self! !

!CSAMethodEvent class methodsFor: 'instance creation' stamp: 'sk 12/17/2011 00:52:10.698'!
forSystemEvent: anAddedEvent
	^ self new
		method: anAddedEvent item;
		protocol: anAddedEvent itemProtocol;    
		yourself 
	! !

!CSAMethodEvent methodsFor: 'accessing' stamp: 'sk 12/16/2011 23:27:41.556'!
method
	^ method! !

!CSAMethodEvent methodsFor: 'accessing' stamp: 'sk 12/16/2011 23:27:41.607'!
method: aCompiledMethod
	method := aCompiledMethod
! !

!CSAMethodEvent methodsFor: 'printing' stamp: 'f.z 1/2/2012 11:15:34.602'!
printEventInformationOn: aStream
	aStream nextPutAll: self method reference, ' in ', self protocol! !

!CSAMethodEvent methodsFor: 'accessing' stamp: 'sk 12/16/2011 23:27:41.618'!
protocol
	^ protocol! !

!CSAMethodEvent methodsFor: 'accessing' stamp: 'sk 12/16/2011 23:27:41.625'!
protocol: aSymbol
	protocol := aSymbol
! !

CSAMethodEvent subclass: #CSAMethodModifiedEvent
	instanceVariableNames: 'oldMethod'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Events'!

!CSAMethodModifiedEvent class methodsFor: 'as yet unclassified' stamp: 'sk 12/17/2011 00:06:10.01'!
forSystemEvent: aMethodModifiedMethod
	^ (super forSystemEvent: aMethodModifiedMethod)
		oldMethod: aMethodModifiedMethod oldItem;
		yourself
	! !

!CSAMethodModifiedEvent methodsFor: 'visitor' stamp: 'sk 12/17/2011 00:03:29.369'!
accept: aTCSAEventHandler
	^ aTCSAEventHandler modifiedMethod: self    ! !

!CSAMethodModifiedEvent methodsFor: 'accessing' stamp: 'sk 12/16/2011 23:43:49.029'!
oldMethod
	^ oldMethod! !

!CSAMethodModifiedEvent methodsFor: 'accessing' stamp: 'sk 12/16/2011 23:43:49.04'!
oldMethod: aCompiledMethod
	oldMethod := aCompiledMethod
! !

CSAMethodEvent subclass: #CSAMethodRecategorizedEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Events'!

!CSAMethodRecategorizedEvent methodsFor: 'visitor' stamp: 'sk 1/6/2012 20:14:11.031'!
accept: aTCSAEventHandler
	^ aTCSAEventHandler recategorizedMethod: self    ! !

CSAMethodEvent subclass: #CSAMethodRemovedEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Events'!

!CSAMethodRemovedEvent methodsFor: 'visitor' stamp: 'sk 12/16/2011 23:42:42.109'!
accept: aTCSEventHandler
	^ aTCSEventHandler removedMethod: self  ! !

Object subclass: #CSAEventAction
	instanceVariableNames: 'eventKind itemKind methodSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA'!

!CSAEventAction class methodsFor: 'instance creation' stamp: 'f.z 1/2/2012 09:42:54.697'!
when: anItemKindSymbol changes: anEventKindSymbol send: aMethodSelector
	^ self new
		itemKind: anItemKindSymbol;
		eventKind: anEventKindSymbol;
		methodSelector: aMethodSelector;
		yourself      ! !

!CSAEventAction methodsFor: 'accessing' stamp: 'f.z 1/2/2012 09:40:23.881'!
eventKind
	^ eventKind! !

!CSAEventAction methodsFor: 'accessing' stamp: 'f.z 1/2/2012 09:40:23.924'!
eventKind: aSymbol
	eventKind := aSymbol
! !

!CSAEventAction methodsFor: 'accessing' stamp: 'f.z 1/2/2012 09:40:23.959'!
itemKind
	^ itemKind! !

!CSAEventAction methodsFor: 'accessing' stamp: 'f.z 1/2/2012 10:15:30.972'!
itemKind: aSymbol
	itemKind := aSymbol
! !

!CSAEventAction methodsFor: 'accessing' stamp: 'f.z 1/2/2012 09:40:24.007'!
methodSelector
	^ methodSelector! !

!CSAEventAction methodsFor: 'accessing' stamp: 'f.z 1/2/2012 09:40:24.03'!
methodSelector: aSymbol
	methodSelector := aSymbol
! !

!CSAEventAction methodsFor: 'notifying' stamp: 'f.z 1/2/2012 10:09:56.109'!
sendNotificationsTo: anEventDispatcher
	SystemChangeNotifier uniqueInstance
		notify: anEventDispatcher
		ofSystemChangesOfItem: self itemKind
		change: self eventKind
		using: self methodSelector! !

!CSAEventAction methodsFor: 'notifying' stamp: 'f.z 1/2/2012 10:17:21.678'!
stopNotifying: anEventDispatcher
	SystemChangeNotifier uniqueInstance noMoreNotificationsFor: anEventDispatcher  ! !

Object subclass: #CSAEventDispatcher
	instanceVariableNames: 'metrics classSource'
	classVariableNames: 'Instances'
	poolDictionaries: ''
	category: 'CSA'!

!CSAEventDispatcher commentStamp: 'sk 1/6/2012 19:37:47.006' prior: 0!
I register myself to the system event hook and dispatch events to my metrics.
I have a class source which can alter these events.!

!CSAEventDispatcher class methodsFor: 'actions' stamp: 'f.z 1/2/2012 09:47:48.446'!
actions
	^ self methodActions
		addAll: self classActions;
		yourself! !

!CSAEventDispatcher class methodsFor: 'actions' stamp: 'sk 1/6/2012 19:38:35.165'!
classActions
	^ OrderedCollection new
		add: self classModifiedAction;
		add: self classRemovedAction;
		add: self classModifiedAction;
		add: self classRenamedAction;
		add: self classRecategorizedAction;
		add: self classCommentedAction;
		yourself! !

!CSAEventDispatcher class methodsFor: 'actions' stamp: 'f.z 1/2/2012 09:59:03.249'!
classAddedAction
	^ CSAEventAction
		when: AbstractEvent classKind
		changes: AddedEvent changeKind
		send: #classAddedEvent:! !

!CSAEventDispatcher class methodsFor: 'actions' stamp: 'sk 1/6/2012 19:38:25.295'!
classCommentedAction
	^ CSAEventAction
		when: AbstractEvent classKind
		changes: CommentedEvent changeKind
		send: #classCommentedEvent:! !

!CSAEventDispatcher class methodsFor: 'actions' stamp: 'f.z 1/2/2012 09:58:39.473'!
classModifiedAction
	^ CSAEventAction
		when: AbstractEvent classKind
		changes: ModifiedEvent changeKind
		send: #classModifiedEvent:! !

!CSAEventDispatcher class methodsFor: 'actions' stamp: 'f.z 1/2/2012 10:00:09.35'!
classRecategorizedAction
	^ CSAEventAction
		when: AbstractEvent classKind
		changes: RecategorizedEvent changeKind
		send: #classRecategorizedEvent:! !

!CSAEventDispatcher class methodsFor: 'actions' stamp: 'f.z 1/2/2012 09:57:58.261'!
classRemovedAction
	^ CSAEventAction
		when: AbstractEvent classKind
		changes: RemovedEvent changeKind
		send: #classRemovedEvent:! !

!CSAEventDispatcher class methodsFor: 'actions' stamp: 'f.z 1/2/2012 09:59:38.618'!
classRenamedAction
	^ CSAEventAction
		when: AbstractEvent classKind
		changes: RenamedEvent changeKind
		send: #classRenamedEvent:! !

!CSAEventDispatcher class methodsFor: 'instance creation' stamp: 'sk 12/16/2011 16:27:15.627'!
for: aCSAClassSource
	^ self instances
		at: aCSAClassSource
		ifAbsentPut: 
			(self new
				classSource: aCSAClassSource;
				yourself)  ! !

!CSAEventDispatcher class methodsFor: 'instance handling' stamp: 'sk 12/16/2011 16:25:26.753'!
instances
	Instances ifNil: [ Instances := Dictionary new ].
	^ Instances
! !

!CSAEventDispatcher class methodsFor: 'instance handling' stamp: 'sk 12/16/2011 16:25:26.874'!
instances: aDictionary
	Instances := aDictionary
! !

!CSAEventDispatcher class methodsFor: 'actions' stamp: 'sk 1/6/2012 20:12:29.142'!
methodActions
	^ OrderedCollection new
		add: self methodModifiedAction;
		add: self methodRemovedAction;
		add: self methodAddedAction;
		add: self methodRecategorizedAction;
		yourself! !

!CSAEventDispatcher class methodsFor: 'actions' stamp: 'f.z 1/2/2012 09:55:26.68'!
methodAddedAction
	^ CSAEventAction
		when: AbstractEvent methodKind
		changes: AddedEvent changeKind
		send: #methodAddedEvent:! !

!CSAEventDispatcher class methodsFor: 'actions' stamp: 'f.z 1/2/2012 09:54:01.378'!
methodModifiedAction
	^ CSAEventAction 
		when: AbstractEvent methodKind
		changes: ModifiedEvent changeKind
		send: #methodModifiedEvent:! !

!CSAEventDispatcher class methodsFor: 'actions' stamp: 'sk 1/6/2012 20:19:10.894'!
methodRecategorizedAction
	^ CSAEventAction 
		when: AbstractEvent methodKind
		changes: RecategorizedEvent changeKind
		send: #methodRecategorizedEvent:! !

!CSAEventDispatcher class methodsFor: 'actions' stamp: 'f.z 1/2/2012 09:54:53.083'!
methodRemovedAction
	^ CSAEventAction
		when: AbstractEvent methodKind
		changes: RemovedEvent changeKind
		send: #methodRemovedEvent:! !

!CSAEventDispatcher class methodsFor: 'instance handling' stamp: 'sk 12/21/2011 21:29:36.799'!
removeAllInstances
	self allInstancesDo:
		[ :dispatcher | dispatcher dismiss ].
	self instances: nil.  ! !

!CSAEventDispatcher methodsFor: 'metrics' stamp: 'sk 12/22/2011 19:03:56.327'!
addMetric: aCSAMetricClass
	^ self metrics 
		at: aCSAMetricClass
		ifAbsent: 
			[self metrics 
				at: aCSAMetricClass 
				put: (aCSAMetricClass 
					for: self classSource 
					withSourceMetrics:  (self addRequiredMetricsFor: aCSAMetricClass))].! !

!CSAEventDispatcher methodsFor: 'metrics' stamp: 'sk 12/22/2011 19:03:43.854'!
addRequiredMetricsFor: aCSAMetricClass
	| requiredMetrics |
	requiredMetrics := Dictionary new.
	aCSAMetricClass requiredMetrics do:
		[ :metricClass |
		requiredMetrics
			at: metricClass
			put: (self addMetric: metricClass) ].
	^ requiredMetrics! !

!CSAEventDispatcher methodsFor: 'dispatching' stamp: 'sk 12/17/2011 16:43:00.849'!
classAddedEvent: anEvent
	self dispatch: (CSAClassAddedEvent forSystemEvent: anEvent)  ! !

!CSAEventDispatcher methodsFor: 'dispatching' stamp: 'sk 1/6/2012 19:39:13.913'!
classCommentedEvent: anEvent
	self dispatch: (CSAClassCommentedEvent forSystemEvent: anEvent)  ! !

!CSAEventDispatcher methodsFor: 'dispatching' stamp: 'sk 12/17/2011 16:29:08.037'!
classModifiedEvent: anEvent
	self dispatch: (CSAClassModifiedEvent forSystemEvent: anEvent)  ! !

!CSAEventDispatcher methodsFor: 'dispatching' stamp: 'sk 12/17/2011 16:29:41.697'!
classRecategorizedEvent: anEvent
	self dispatch: (CSAClassRecategorizedEvent forSystemEvent: anEvent)  ! !

!CSAEventDispatcher methodsFor: 'dispatching' stamp: 'sk 12/17/2011 15:55:02.96'!
classRemovedEvent: aRemovedEvent
	self dispatch: (CSAClassRemovedEvent forSystemEvent: aRemovedEvent)  ! !

!CSAEventDispatcher methodsFor: 'dispatching' stamp: 'sk 12/17/2011 16:42:14.56'!
classRenamedEvent: anEvent
	self dispatch: (CSAClassRenamedEvent forSystemEvent: anEvent)  ! !

!CSAEventDispatcher methodsFor: 'accessing' stamp: 'sk 12/16/2011 16:33:52.754'!
classSource
	^ classSource! !

!CSAEventDispatcher methodsFor: 'accessing' stamp: 'sk 12/16/2011 16:33:52.766'!
classSource: aCSAClassSource
	classSource := aCSAClassSource
! !

!CSAEventDispatcher methodsFor: 'initialize' stamp: 'sk 12/21/2011 21:29:26.21'!
dismiss
	self unregisterAsObserver.
	self metrics do:
		[ :metric | metric dismiss ]! !

!CSAEventDispatcher methodsFor: 'dispatching' stamp: 'sk 1/8/2012 01:09:13.118'!
dispatch: aCSAEvent
	(self classSource adjust: aCSAEvent) ifNotNilDo: 
		[ :event | 
		Transcript cr; show: 'dispatching ', aCSAEvent, ' -> ', event; cr.
		self metrics do: [ :metric | metric handle: event ] ]  
! !

!CSAEventDispatcher methodsFor: 'initialize' stamp: 'sk 12/16/2011 16:34:48.302'!
initialize
	super initialize.
	^ self
		initializeState;
		registerAsObserver;
		yourself ! !

!CSAEventDispatcher methodsFor: 'initialize' stamp: 'sk 12/16/2011 23:59:56.137'!
initializeState
	self metrics: Dictionary new.! !

!CSAEventDispatcher methodsFor: 'dispatching' stamp: 'sk 12/17/2011 15:53:44.475'!
methodAddedEvent: anAddedEvent
	self dispatch: (CSAMethodAddedEvent forSystemEvent: anAddedEvent)  ! !

!CSAEventDispatcher methodsFor: 'dispatching' stamp: 'sk 12/17/2011 15:37:34.821'!
methodModifiedEvent: aModifiedEvent
	self dispatch: (CSAMethodModifiedEvent forSystemEvent: aModifiedEvent)  ! !

!CSAEventDispatcher methodsFor: 'dispatching' stamp: 'sk 1/6/2012 20:15:59.594'!
methodRecategorizedEvent: aRecategorizedEvent
	self dispatch: (CSAMethodRecategorizedEvent forSystemEvent: aRecategorizedEvent)  ! !

!CSAEventDispatcher methodsFor: 'dispatching' stamp: 'sk 12/17/2011 15:54:41.877'!
methodRemovedEvent: aRemovedEvent
	self dispatch: (CSAMethodRemovedEvent forSystemEvent: aRemovedEvent)  ! !

!CSAEventDispatcher methodsFor: 'accessing' stamp: 'sk 12/16/2011 16:33:52.714'!
metrics
	^ metrics! !

!CSAEventDispatcher methodsFor: 'accessing' stamp: 'sk 12/16/2011 16:33:52.735'!
metrics: aCSAMetric
	metrics := aCSAMetric
! !

!CSAEventDispatcher methodsFor: 'initialize' stamp: 'f.z 1/9/2012 16:36:38.825'!
refresh
	self metrics do:
		[ :metric | metric initializeFrom: self classSource ]! !

!CSAEventDispatcher methodsFor: 'observing' stamp: 'f.z 1/2/2012 10:10:30.186'!
registerAsObserver 
	self class actions do:
		[ :action | action sendNotificationsTo: self ]! !

!CSAEventDispatcher methodsFor: 'metrics' stamp: 'sk 12/22/2011 21:05:34.594'!
removeChildMetricsOf: aCSAMetric
	self metrics keysAndValuesDo:
		 [ :class :metric | (metric sourceMetrics includes: aCSAMetric)
			ifTrue: [ self removeMetric: class ] ]  ! !

!CSAEventDispatcher methodsFor: 'metrics' stamp: 'sk 12/22/2011 19:28:01.342'!
removeMetric: aCSAMetricClass
	| metric |
	metric := self metrics at: aCSAMetricClass ifAbsent: [ ^ self ].
	self removeChildMetricsOf: metric.
	metric dismiss.
	self metrics removeKey: aCSAMetricClass! !

!CSAEventDispatcher methodsFor: 'observing' stamp: 'f.z 1/2/2012 10:11:56.039'!
unregisterAsObserver
	self class actions do:
		[ :action | action stopNotifying: self ]! !

CSAEventDispatcher subclass: #CSANullEventDispatcher
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA'!

!CSANullEventDispatcher methodsFor: 'dispatching' stamp: 'f.z 1/9/2012 13:00:35.937'!
dispatch: anEvent
	^ self! !

!CSANullEventDispatcher methodsFor: 'initialize' stamp: 'f.z 1/9/2012 13:04:28.738'!
initialize
	super initialize.
	self classSource: CSAEmptyClassSource new! !

!CSANullEventDispatcher methodsFor: 'observing' stamp: 'f.z 1/9/2012 13:01:35.194'!
registerAsObserver
	^ self! !

!CSANullEventDispatcher methodsFor: 'observing' stamp: 'f.z 1/9/2012 13:01:39.946'!
unregisterAsObserver
	^ self! !

Object subclass: #CSAMetric
	uses: TCSAEventHandler
	instanceVariableNames: 'classSource sourceMetrics'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics'!

CSAMetric class
	uses: TCSAEventHandler classTrait
	instanceVariableNames: ''!

CSAMetric subclass: #CSAClassCollectionMetric
	instanceVariableNames: 'classes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics'!

CSAClassCollectionMetric subclass: #CSAClassBasedRBRuleMetric
	instanceVariableNames: 'rule'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics'!

!CSAClassBasedRBRuleMetric methodsFor: 'as yet unclassified' stamp: 'ck 1/9/2012 11:38:41.85'!
accepts: anObject
	self subclassResponsibility ! !

!CSAClassBasedRBRuleMetric methodsFor: 'as yet unclassified' stamp: 'ck 1/9/2012 11:22:10.686'!
initializeEnvironment: anEnvironment with: anObject
	self subclassResponsibility ! !

!CSAClassBasedRBRuleMetric methodsFor: 'as yet unclassified' stamp: 'ck 1/9/2012 11:05:38.71'!
initializeState 
	super initializeState.
	rule := self rule! !

!CSAClassBasedRBRuleMetric methodsFor: 'as yet unclassified' stamp: 'ck 1/9/2012 11:05:49.958'!
rule
	self subclassResponsibility ! !

!CSAClassBasedRBRuleMetric methodsFor: 'as yet unclassified' stamp: 'ck 1/9/2012 11:51:54.424'!
shallContain: anObject
	^ (self accepts: anObject) and: [  
	(rule runOnEnvironment: (self initializeEnvironment: (rule resultClass new) with: anObject))
		isEmpty not]! !

CSAClassBasedRBRuleMetric subclass: #CSAClassNotReferencesSmell
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics'!

!CSAClassNotReferencesSmell methodsFor: 'as yet unclassified' stamp: 'ck 1/9/2012 11:49:37.07'!
accepts: anObject
	^ anObject isCompiledMethod not! !

!CSAClassNotReferencesSmell methodsFor: 'as yet unclassified' stamp: 'ck 1/9/2012 11:22:40.918'!
initializeEnvironment: anEnvironment with: aClass
	^ anEnvironment 
		addClass: aClass;
		yourself! !

!CSAClassNotReferencesSmell methodsFor: 'as yet unclassified' stamp: 'ck 1/8/2012 12:50:18.047'!
rule
	^ RBClassNotReferencedRule new! !

CSAClassBasedRBRuleMetric subclass: #CSAInconsistentMethodClassificationSmell
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics'!

!CSAInconsistentMethodClassificationSmell methodsFor: 'as yet unclassified' stamp: 'ck 1/9/2012 11:49:44.212'!
accepts: anObject
	^ anObject isCompiledMethod not! !

!CSAInconsistentMethodClassificationSmell methodsFor: 'as yet unclassified' stamp: 'ck 1/9/2012 11:28:54.534'!
initializeEnvironment: anEnvironment with: aCompiledMethod
	^ anEnvironment 
		addClass: aCompiledMethod methodClass 
		selector: aCompiledMethod selector 
		into: (aCompiledMethod methodClass name, '>>', aCompiledMethod selector asString);
	 	yourself ! !

!CSAInconsistentMethodClassificationSmell methodsFor: 'as yet unclassified' stamp: 'ck 1/8/2012 12:26:53.511'!
rule
	 ^ RBInconsistentMethodClassificationRule new! !

CSAClassBasedRBRuleMetric subclass: #CSAMissingSubclassResponsibilitySmell
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics'!

!CSAMissingSubclassResponsibilitySmell methodsFor: 'as yet unclassified' stamp: 'ck 1/9/2012 15:19:52.892'!
accepts: anObject
	^ anObject isCompiledMethod! !

!CSAMissingSubclassResponsibilitySmell methodsFor: 'as yet unclassified' stamp: 'ck 1/9/2012 15:20:38.508'!
initializeEnvironment: anEnvironment with: aCompiledMethod
	^ anEnvironment 
		addClass: aCompiledMethod methodClass
		selector: aCompiledMethod selector
		into: (aCompiledMethod methodClass name, '>>',aCompiledMethod selector asString)
		yourself! !

!CSAMissingSubclassResponsibilitySmell methodsFor: 'as yet unclassified' stamp: 'ck 1/8/2012 12:05:06.114'!
rule 
	^ RBMissingSubclassResponsibilityRule new! !

!CSAClassCollectionMetric class methodsFor: 'accessing' stamp: 'f.z 1/9/2012 16:45:43.385'!
columnTitle
	^ 'Classes'! !

!CSAClassCollectionMetric methodsFor: 'class events' stamp: 'sk 1/6/2012 21:22:58.814'!
addedClass: aCSAClassAddedEvent
	self
		testAndAdd: aCSAClassAddedEvent newClass theNonMetaClass;
		testAndAdd: aCSAClassAddedEvent newClass theMetaClass  ! !

!CSAClassCollectionMetric methodsFor: 'method events' stamp: 'sk 1/6/2012 18:57:15.546'!
addedMethod: aCSAMethodAddedEvent
	self testAndAdd: aCSAMethodAddedEvent method methodClass! !

!CSAClassCollectionMetric methodsFor: 'accessing' stamp: 'sk 1/6/2012 18:47:44.742'!
classes
	^ classes! !

!CSAClassCollectionMetric methodsFor: 'accessing' stamp: 'sk 1/6/2012 18:47:44.753'!
classes: aSet
	classes := aSet
! !

!CSAClassCollectionMetric methodsFor: 'accessing' stamp: 'f.z 1/9/2012 16:46:18.265'!
columnContents
	^ self classes asString! !

!CSAClassCollectionMetric methodsFor: 'class events' stamp: 'sk 1/6/2012 23:05:07.588'!
commentedClass: aCSAClassCommentedEvent
	self updateClass: aCSAClassCommentedEvent commentedClass  ! !

!CSAClassCollectionMetric methodsFor: 'initialize-release' stamp: 'sk 1/6/2012 18:54:17.185'!
initializeFrom: aCSAClassSource
	  aCSAClassSource allClasses do:
		[ :class | self testAndAdd: class ]  ! !

!CSAClassCollectionMetric methodsFor: 'initialize-release' stamp: 'sk 1/6/2012 22:57:18.339'!
initializeState
	super initializeState.
	self classes: IdentitySet new! !

!CSAClassCollectionMetric methodsFor: 'class events' stamp: 'sk 1/6/2012 22:58:24.148'!
modifiedClass: aCSAClassModifiedClassEvent
	self
		remove: aCSAClassModifiedClassEvent newClass; "Attention: newClass == the old class"
		testAndAdd: aCSAClassModifiedClassEvent newClass! !

!CSAClassCollectionMetric methodsFor: 'method events' stamp: 'sk 1/6/2012 18:58:33.931'!
modifiedMethod: aCSAMethodModifiedEvent
	self
		remove: aCSAMethodModifiedEvent oldMethod methodClass;
		testAndAdd: aCSAMethodModifiedEvent method methodClass    ! !

!CSAClassCollectionMetric methodsFor: 'class events' stamp: 'sk 1/6/2012 23:06:01.052'!
recategorizedClass: aCSAClassRecategorizedClassEvent
	self updateClass: aCSAClassRecategorizedClassEvent movedClass    ! !

!CSAClassCollectionMetric methodsFor: 'metric computation' stamp: 'sk 1/6/2012 18:55:02.898'!
remove: aClass
	self classes
		remove: aClass
		ifAbsent: [] ! !

!CSAClassCollectionMetric methodsFor: 'class events' stamp: 'sk 1/6/2012 21:22:10.827'!
removedClass: aCSAClassRemovedEvent
	self
		remove: aCSAClassRemovedEvent removedClass theNonMetaClass;
		remove: aCSAClassRemovedEvent removedClass theMetaClass! !

!CSAClassCollectionMetric methodsFor: 'method events' stamp: 'sk 1/6/2012 19:00:48.92'!
removedMethod: aCSAMethodRemovedEvent
	self testAndRemove: aCSAMethodRemovedEvent method methodClass  ! !

!CSAClassCollectionMetric methodsFor: 'class events' stamp: 'sk 1/6/2012 23:07:46.604'!
renamedClass: aCSAClassRenamedClassEvent
	self updateClass: aCSAClassRenamedClassEvent renamedClass  ! !

!CSAClassCollectionMetric methodsFor: 'metric computation' stamp: 'sk 1/6/2012 19:30:36.004'!
shallContain: aClass
	self subclassResponsibility! !

!CSAClassCollectionMetric methodsFor: 'metric computation' stamp: 'f.z 1/9/2012 17:35:02.649'!
testAndAdd: aClass
	(self shallContain: aClass) ifTrue: [ self classes add: aClass ].
	self triggerChange! !

!CSAClassCollectionMetric methodsFor: 'method events' stamp: 'f.z 1/9/2012 17:35:18.715'!
testAndRemove: aClass
	(self shallContain: aClass) ifFalse: [ self remove: aClass ].
	self triggerChange! !

!CSAClassCollectionMetric methodsFor: 'metric computation' stamp: 'sk 1/6/2012 23:04:47.565'!
updateClass: aClass
	self
		remove: aClass;
		testAndAdd: aClass    ! !

CSAClassCollectionMetric subclass: #CSAGlobalStateMetric
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics'!

!CSAGlobalStateMetric methodsFor: 'metric computation' stamp: 'sk 1/6/2012 21:14:51.638'!
classVariablesOf: aClass
	^ OrderedCollection new
		addAll: aClass class instVarNames;
		addAll: aClass classVarNames;
		yourself! !

!CSAGlobalStateMetric methodsFor: 'class events' stamp: 'sk 1/6/2012 23:13:50.201'!
modifiedClass: aCSAClassModifiedClassEvent
	"We only store the non-meta class but also need to keep track of meta class changes.."
	self updateClass: aCSAClassModifiedClassEvent newClass theNonMetaClass    ! !

!CSAGlobalStateMetric methodsFor: 'metric computation' stamp: 'sk 1/6/2012 23:00:29.093'!
shallContain: aClass
	^ aClass isMeta not and: 
		[ (self classVariablesOf: aClass) isEmpty not or: [ self class instVarNames isEmpty not ] ]! !

CSAClassCollectionMetric subclass: #CSAUncommentedClassesMetric
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics'!

!CSAUncommentedClassesMetric methodsFor: 'metric computation' stamp: 'sk 1/6/2012 23:14:11.998'!
shallContain: aClass
	^ aClass isMeta not and: [ aClass comment isText not ]! !

CSAMetric subclass: #CSAExploreMetric
	instanceVariableNames: 'classes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics'!

!CSAExploreMetric class methodsFor: 'accessing' stamp: 'f.z 1/9/2012 16:59:26.826'!
columnTitle
	^ 'Classes'! !

!CSAExploreMetric methodsFor: 'general handling' stamp: 'sk 1/6/2012 21:57:09.316'!
handle: aCSAEvent
	super handle: aCSAEvent.
	aCSAEvent explore  ! !

!CSAExploreMetric methodsFor: 'initialize-release' stamp: 'sk 1/6/2012 21:56:05.138'!
initializeFrom: aClassSource! !

CSAMetric subclass: #CSAInheritanceDepthMetric
	instanceVariableNames: 'depthCounter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics'!

!CSAInheritanceDepthMetric class methodsFor: 'accessing' stamp: 'f.z 1/9/2012 17:05:44.393'!
columnTitle
	^ 'Inheritance Depth'! !

!CSAInheritanceDepthMetric methodsFor: 'class events' stamp: 'sk 12/17/2011 20:14:43.021'!
addedClass: aCSAClassAddedEvent
	self countClass: aCSAClassAddedEvent newClass  ! !

!CSAInheritanceDepthMetric methodsFor: 'metric computation' stamp: 'sk 12/17/2011 20:34:28.491'!
averageDepth
	^ self classCount == 0 ifTrue: [ 0 ] ifFalse: [ self depthSum / self classCount ]! !

!CSAInheritanceDepthMetric methodsFor: 'metric computation' stamp: 'sk 12/21/2011 22:00:58.306'!
classCount
	^ self depthCounter size! !

!CSAInheritanceDepthMetric methodsFor: 'accessing' stamp: 'f.z 1/9/2012 17:06:15.753'!
columnContents
	^ 'Min depth: ', self minimumDepth, String cr,
		'Max depth: ', self maximumDepth, String cr,
		'Average depth: ', (self averageDepth asFloat roundTo: 0.01)! !

!CSAInheritanceDepthMetric methodsFor: 'metric computation' stamp: 'f.z 1/9/2012 17:08:11.369'!
countClass: aClass
	| depth |
	depth := self determineInheritenceDepth: aClass.
	depth >= 0 ifTrue: [ self updateDepthOf: aClass to: depth ].
	^ depth! !

!CSAInheritanceDepthMetric methodsFor: 'accessing' stamp: 'sk 12/17/2011 19:49:55.589'!
depthCounter
	^ depthCounter! !

!CSAInheritanceDepthMetric methodsFor: 'accessing' stamp: 'sk 12/17/2011 19:49:55.641'!
depthCounter: aDictionary
	depthCounter := aDictionary
! !

!CSAInheritanceDepthMetric methodsFor: 'metric computation' stamp: 'sk 12/21/2011 22:01:26.89'!
depthSum
	^ self depthCounter values 
		inject: 0 
		into: [ :sum :depth | sum + depth ]! !

!CSAInheritanceDepthMetric methodsFor: 'metric computation' stamp: 'sk 12/17/2011 20:38:43.765'!
determineInheritenceDepth: aClass
	| depth curClass |
	depth := 0.
	curClass := aClass.
	[ curClass ~= Object ] whileTrue: 
		[ (curClass == nil) ifTrue: [ ^ -1 ].  
		curClass := curClass superclass.
		depth := depth + 1 ].
	^ depth   ! !

!CSAInheritanceDepthMetric methodsFor: 'initialize-release' stamp: 'sk 12/21/2011 21:00:50.979'!
initialize
	super initialize.
	self depthCounter: Dictionary new  ! !

!CSAInheritanceDepthMetric methodsFor: 'initialize-release' stamp: 'f.z 1/5/2012 12:54:34.273'!
initializeFrom: aCSAClassSource
	aCSAClassSource classes do: [ :class | self countClass: class ]  
! !

!CSAInheritanceDepthMetric methodsFor: 'metric computation' stamp: 'sk 12/21/2011 22:00:27.406'!
maximumDepth
	^ self depthCounter values
		inject: 0
		into: [ :max :cur | max max: cur ]! !

!CSAInheritanceDepthMetric methodsFor: 'metric computation' stamp: 'sk 12/21/2011 22:45:43'!
minimumDepth
	^ self depthCounter 
		ifEmpty: [ 0 ]
	 	ifNotEmptyDo: 
			[ :counter | counter values
				inject: SmalltalkImage current allClasses size
				into: [ :min :cur | min min: cur ] ]
! !

!CSAInheritanceDepthMetric methodsFor: 'class events' stamp: 'sk 12/21/2011 23:20:10.961'!
modifiedClass: aClassModifiedEvent
	self updateDepthOf: (aClassModifiedEvent newClass)  ! !

!CSAInheritanceDepthMetric methodsFor: 'class events' stamp: 'sk 12/17/2011 20:14:53.424'!
removedClass: aCSAClassRemovedEvent
	self uncountClass: aCSAClassRemovedEvent removedClass  ! !

!CSAInheritanceDepthMetric methodsFor: 'metric computation' stamp: 'f.z 1/9/2012 17:35:23.689'!
uncountClass: aClass
	| depth |
	depth := self depthCounter removeKey: aClass name.
	self triggerChange.
	^ depth! !

!CSAInheritanceDepthMetric methodsFor: 'metric computation' stamp: 'sk 12/21/2011 23:19:46.565'!
updateDepthOf: aClass
	(self uncountClass: aClass) ~= (self countClass: aClass) ifTrue:
		[ aClass subclassesDo: 
			[ :subclass | 
			(self depthCounter keys contains: [ :key | key == subclass name ]) 
				ifTrue: [ self updateDepthOf: subclass ]  ]  ]! !

!CSAInheritanceDepthMetric methodsFor: 'metric computation' stamp: 'f.z 1/9/2012 17:35:28.025'!
updateDepthOf: aClass to: aNumber
	self depthCounter at: aClass name put: aNumber.
	self triggerChange! !

CSAMetric subclass: #CSALinesOfCodeMetric
	instanceVariableNames: 'linesOfCode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics'!

!CSALinesOfCodeMetric class methodsFor: 'accessing' stamp: 'f.z 1/9/2012 17:02:08.137'!
columnTitle
	^ 'LOC'! !

!CSALinesOfCodeMetric methodsFor: 'class events' stamp: 'sk 12/22/2011 14:00:36.448'!
addedClass: aCSAClassAddedEvent
	self countClass: aCSAClassAddedEvent newClass  ! !

!CSALinesOfCodeMetric methodsFor: 'method events' stamp: 'sk 12/22/2011 14:01:18.485'!
addedMethod: aCSAMethodAddedEvent
	self countMethod: aCSAMethodAddedEvent method  ! !

!CSALinesOfCodeMetric methodsFor: 'accessing' stamp: 'f.z 1/9/2012 17:02:40.569'!
columnContents
	^ 'LOC: ', self linesOfCode! !

!CSALinesOfCodeMetric methodsFor: 'observing' stamp: 'sk 12/22/2011 14:00:13.744'!
countClass: aClass
	aClass methodDict valuesDo: [ :method | self countMethod:  method ]! !

!CSALinesOfCodeMetric methodsFor: 'observing' stamp: 'sk 12/22/2011 13:58:23.67'!
countMethod: aCompiledMethod
	self linesOfCode: self linesOfCode + aCompiledMethod linesOfCode    ! !

!CSALinesOfCodeMetric methodsFor: 'initialize' stamp: 'sk 12/22/2011 11:46:13.592'!
initialize
	super initialize.  
	self linesOfCode: 0  ! !

!CSALinesOfCodeMetric methodsFor: 'initialize' stamp: 'f.z 1/5/2012 12:46:13.2'!
initializeFrom: aClassSource
	self linesOfCode:
		(aClassSource allClasses 
			inject: 0 into: [ :sum :class | sum + class linesOfCode])! !

!CSALinesOfCodeMetric methodsFor: 'accessing' stamp: 'f.z 12/5/2011 16:06:43.078'!
linesOfCode
	^ linesOfCode! !

!CSALinesOfCodeMetric methodsFor: 'accessing' stamp: 'f.z 1/9/2012 17:35:31.993'!
linesOfCode: anInteger
	linesOfCode := anInteger.
	self triggerChange! !

!CSALinesOfCodeMetric methodsFor: 'method events' stamp: 'sk 12/22/2011 14:02:14.22'!
modifiedMethod: aCSAMethodModifiedEvent
	self
		uncountMethod: aCSAMethodModifiedEvent oldMethod;     
		countMethod: aCSAMethodModifiedEvent method! !

!CSALinesOfCodeMetric methodsFor: 'class events' stamp: 'sk 12/22/2011 14:29:11.094'!
removedClass: aCSAClassRemovedEvent
	self uncountClass: aCSAClassRemovedEvent removedClass  ! !

!CSALinesOfCodeMetric methodsFor: 'method events' stamp: 'sk 12/22/2011 14:02:56.824'!
removedMethod: aCSAMethodRemovedEvent
	self	uncountMethod: aCSAMethodRemovedEvent method! !

!CSALinesOfCodeMetric methodsFor: 'observing' stamp: 'sk 12/22/2011 14:00:01.2'!
uncountClass: aClass
	aClass methodDict valuesDo: [ :method | self uncountMethod:  method ]! !

!CSALinesOfCodeMetric methodsFor: 'observing' stamp: 'sk 12/22/2011 13:58:35.085'!
uncountMethod: aCompiledMethod
	self linesOfCode: self linesOfCode - aCompiledMethod linesOfCode    ! !

CSAMetric subclass: #CSALinesPerMethodMetrics
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics'!

!CSALinesPerMethodMetrics class methodsFor: 'accessing' stamp: 'f.z 1/9/2012 17:13:45.241'!
columnTitle
	^ 'LPM'! !

!CSALinesPerMethodMetrics class methodsFor: 'dependencies' stamp: 'sk 12/22/2011 19:17:34.537'!
requiredMetrics
	^ {CSANumberOfMethodsMetric . CSALinesOfCodeMetric}! !

!CSALinesPerMethodMetrics methodsFor: 'accessing' stamp: 'f.z 1/9/2012 17:14:49.817'!
columnContents
	^ 'LPM: ', (self linesPerMethod asFloat roundTo: 0.01)! !

!CSALinesPerMethodMetrics methodsFor: 'initialize-release' stamp: 'sk 12/22/2011 19:21:54.612'!
initializeFrom: aCSAClassSource
	"Let the source metrics do the work"  ! !

!CSALinesPerMethodMetrics methodsFor: 'accessing' stamp: 'sk 12/22/2011 21:52:25.608'!
linesPerMethod
	| methods |
	methods := self nomMetric methodCount.
	^ methods isZero
		ifFalse: [ self locMetric linesOfCode / methods ]
		ifTrue: [ 0 ]    ! !

!CSALinesPerMethodMetrics methodsFor: 'accessing' stamp: 'sk 12/22/2011 19:07:05.622'!
locMetric
	^ self sourceMetrics at: CSALinesOfCodeMetric! !

!CSALinesPerMethodMetrics methodsFor: 'accessing' stamp: 'sk 12/22/2011 19:07:23.22'!
nomMetric
	^ self sourceMetrics at: CSANumberOfMethodsMetric! !

CSAMetric subclass: #CSAMethodCollectionMetric
	instanceVariableNames: 'methods'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics'!

CSAMethodCollectionMetric subclass: #CSAMetaProgrammingMetric
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics'!

!CSAMetaProgrammingMetric methodsFor: 'metric computation' stamp: 'sk 1/6/2012 19:32:45.82'!
shallContain: aCompiledMethod
	^ (SLSwaMetricsPlugIn new methodUsesMetaprogramming:     
		(SLMethodTestObject newFrom: aCompiledMethod)) isPositive! !

CSAMethodCollectionMetric subclass: #CSAMethodBasedRBRuleMetric
	instanceVariableNames: 'rule'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics'!

CSAMethodBasedRBRuleMetric subclass: #CSAAssignmentWithoutEffectMetric
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics'!

!CSAAssignmentWithoutEffectMetric methodsFor: 'initialize-release' stamp: 'sk 1/7/2012 21:07:52.728'!
rule
	^ RBAssignmentWithoutEffectRule new! !

CSAMethodBasedRBRuleMetric subclass: #CSADebuggingCodeSmell
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics'!

!CSADebuggingCodeSmell methodsFor: 'initialize-release' stamp: 'sk 1/8/2012 00:23:12.436'!
rule
	^ RBCodeCruftLeftInMethodsRule new! !

CSAMethodBasedRBRuleMetric subclass: #CSAEmptyExceptionHandlerSmell
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics'!

!CSAEmptyExceptionHandlerSmell methodsFor: 'initialize-release' stamp: 'sk 1/8/2012 00:20:20.567'!
rule
	^ RBEmptyExceptionHandlerRule new! !

CSAMethodBasedRBRuleMetric subclass: #CSAIncompleteConditionalReturnSmell
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics'!

!CSAIncompleteConditionalReturnSmell methodsFor: 'initialize-release' stamp: 'sk 1/7/2012 23:18:06.458'!
rule
	^ RBReturnsIfTrueRule new! !

CSAMethodBasedRBRuleMetric subclass: #CSAJustSendsSuperSmell
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics'!

!CSAJustSendsSuperSmell methodsFor: 'as yet unclassified' stamp: 'ck 1/8/2012 12:23:13.102'!
rule
	^ RBJustSendsSuperRule new! !

CSAMethodBasedRBRuleMetric subclass: #CSALawOfDemeterSmell
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics'!

!CSALawOfDemeterSmell methodsFor: 'initialize-release' stamp: 'sk 1/7/2012 23:23:50.717'!
rule
	^ RBLawOfDemeterRule new! !

!CSAMethodBasedRBRuleMetric methodsFor: 'initialize-release' stamp: 'sk 1/7/2012 21:07:10.182'!
initializeState 
	super initializeState.
	rule := self rule! !

!CSAMethodBasedRBRuleMetric methodsFor: 'initialize-release' stamp: 'sk 1/7/2012 21:07:16.323'!
rule
	self subclassResponsibility! !

!CSAMethodBasedRBRuleMetric methodsFor: 'metric computation' stamp: 'ck 1/9/2012 15:32:06.866'!
shallContain: aCompiledMethod
	^ (rule runOnEnvironment:
		(SelectorEnvironment new
			addClass: aCompiledMethod methodClass
			selector: aCompiledMethod selector;
			yourself))
		isEmpty not
! !

CSAMethodBasedRBRuleMetric subclass: #CSAMissedShortcutMethodsSmell
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics'!

!CSAMissedShortcutMethodsSmell methodsFor: 'initialize-release' stamp: 'sk 1/8/2012 00:18:40.66'!
rule
	^ RBConsistencyCheckRule new! !

CSAMethodBasedRBRuleMetric subclass: #CSAMissingYourselfSmell
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics'!

!CSAMissingYourselfSmell methodsFor: 'initialize-release' stamp: 'sk 1/7/2012 23:10:29.435'!
rule
	^ RBMissingYourselfRule new! !

CSAMethodBasedRBRuleMetric subclass: #CSAMistakablePrecedenceSmell
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics'!

!CSAMistakablePrecedenceSmell methodsFor: 'initialize-release' stamp: 'sk 1/7/2012 23:14:33.338'!
rule
	^ RBPrecedenceRule new! !

CSAMethodBasedRBRuleMetric subclass: #CSAModifyingIteratedCollectionSmell
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics'!

!CSAModifyingIteratedCollectionSmell methodsFor: 'initialize-release' stamp: 'sk 1/7/2012 23:06:02.879'!
rule
	^ RBModifiesCollectionRule new! !

CSAMethodBasedRBRuleMetric subclass: #CSAPlatformDependentUserInteractionSmell
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics'!

!CSAPlatformDependentUserInteractionSmell methodsFor: 'initialize-release' stamp: 'sk 1/7/2012 23:08:35.616'!
rule
	^ RBPlatformDependentUserInteractionRule new! !

CSAMethodBasedRBRuleMetric subclass: #CSAPotentiallyUnsendMethodSmell
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics'!

!CSAPotentiallyUnsendMethodSmell methodsFor: 'as yet unclassified' stamp: 'ck 1/8/2012 12:28:33.3'!
rule
	^ RBImplementedNotSentRule new! !

CSAMethodBasedRBRuleMetric subclass: #CSASameTrueAndFalsCodeSmell
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics'!

!CSASameTrueAndFalsCodeSmell methodsFor: 'initialize-release' stamp: 'sk 1/8/2012 00:14:15.917'!
rule
	^ RBEndTrueFalseRule new! !

CSAMethodBasedRBRuleMetric subclass: #CSAThreeElementPointSmell
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics'!

!CSAThreeElementPointSmell methodsFor: 'initialize-release' stamp: 'sk 1/7/2012 22:30:30.235'!
rule
	^ RBThreeElementPointRule new! !

CSAMethodBasedRBRuleMetric subclass: #CSAUnconditionalRecursionSmell
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics'!

!CSAUnconditionalRecursionSmell methodsFor: 'initialize-release' stamp: 'sk 1/7/2012 22:21:50.733'!
rule
	^ RBUnconditionalRecursionRule new! !

CSAMethodBasedRBRuleMetric subclass: #CSAUndeclaredReferenceProblem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics'!

!CSAUndeclaredReferenceProblem methodsFor: 'initialize-release' stamp: 'ck 1/8/2012 12:19:16.834'!
rule
	^ RBUndeclaredReferenceRule new! !

CSAMethodBasedRBRuleMetric subclass: #CSAUnnecessarySizeCheckSmell
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics'!

!CSAUnnecessarySizeCheckSmell methodsFor: 'initialize-release' stamp: 'sk 1/7/2012 22:39:14.344'!
rule
	^ RBSizeCheckRule new! !

CSAMethodBasedRBRuleMetric subclass: #CSAUnusedEqualResultSmell
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics'!

!CSAUnusedEqualResultSmell methodsFor: 'initialize-release' stamp: 'sk 1/8/2012 00:16:43.555'!
rule
	^ RBEqualNotUsedRule new! !

CSAMethodBasedRBRuleMetric subclass: #CSAUnusedVariablesSmell
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics'!

!CSAUnusedVariablesSmell methodsFor: 'initialize-release' stamp: 'sk 1/7/2012 23:20:23.554'!
rule
	^ RBOnlyReadOrWrittenTemporaryRule new! !

!CSAMethodCollectionMetric class methodsFor: 'accessing' stamp: 'f.z 1/9/2012 17:15:15.529'!
columnTitle
	^ 'Methods'! !

!CSAMethodCollectionMetric methodsFor: 'class events' stamp: 'sk 1/6/2012 21:33:13.025'!
addedClass: aCSAClassAddedEvent
	self testAndAddAllMethodsOf: aCSAClassAddedEvent newClass  ! !

!CSAMethodCollectionMetric methodsFor: 'method events' stamp: 'sk 1/6/2012 17:53:01.405'!
addedMethod: aCSAMethodAddedEvent
	self testAndAdd: aCSAMethodAddedEvent method  ! !

!CSAMethodCollectionMetric methodsFor: 'metric computation' stamp: 'sk 1/8/2012 01:12:03.061'!
buildStableRepresentationOf: aCompiledMethod
	^ aCompiledMethod methodClass -> aCompiledMethod selector! !

!CSAMethodCollectionMetric methodsFor: 'accessing' stamp: 'f.z 1/9/2012 17:15:38.329'!
columnContents
	self methods asString! !

!CSAMethodCollectionMetric methodsFor: 'initialize-release' stamp: 'sk 1/6/2012 17:51:06.367'!
initializeFrom: aCSAClassSource
	  aCSAClassSource allClasses do:
		[ :class | class methodDict valuesDo: 
			[ :method | self testAndAdd: method ] ]! !

!CSAMethodCollectionMetric methodsFor: 'initialize-release' stamp: 'sk 1/6/2012 18:33:48.603'!
initializeState
	super initializeState.
	self methods: Set new! !

!CSAMethodCollectionMetric methodsFor: 'accessing' stamp: 'sk 1/6/2012 18:28:59.955'!
methods
	^ methods! !

!CSAMethodCollectionMetric methodsFor: 'accessing' stamp: 'sk 1/6/2012 18:28:45.744'!
methods: aSet
	methods := aSet
! !

!CSAMethodCollectionMetric methodsFor: 'method events' stamp: 'sk 1/6/2012 17:55:49.712'!
modifiedMethod: aCSAMethodModifiedEvent
	self
		remove: aCSAMethodModifiedEvent oldMethod;
		testAndAdd: aCSAMethodModifiedEvent method    ! !

!CSAMethodCollectionMetric methodsFor: 'method events' stamp: 'sk 1/6/2012 20:21:03.676'!
recategorizedMethod: aCSAMethodRecategorizedEvent
	self 
		remove: aCSAMethodRecategorizedEvent method;
		testAndAdd: aCSAMethodRecategorizedEvent method  ! !

!CSAMethodCollectionMetric methodsFor: 'metric computation' stamp: 'f.z 1/9/2012 17:35:37.961'!
remove: aCompiledMethod
	self methods
		remove: (self buildStableRepresentationOf: aCompiledMethod)
		ifAbsent: [ ^ self ].
	self triggerChange! !

!CSAMethodCollectionMetric methodsFor: 'metric computation' stamp: 'sk 1/6/2012 21:35:16.879'!
removeAllMethodsOf: aClass
	self
		removeAllOf: aClass theNonMetaClass methodDict;
		removeAllOf: aClass theMetaClass methodDict! !

!CSAMethodCollectionMetric methodsFor: 'metric computation' stamp: 'sk 1/6/2012 21:34:23.301'!
removeAllOf: aMethodDictionary
	aMethodDictionary valuesDo: [ :method | self remove: method ]  ! !

!CSAMethodCollectionMetric methodsFor: 'class events' stamp: 'sk 1/6/2012 21:37:59.658'!
removedClass: aCSAClassRemovedEvent
	self removeAllMethodsOf: aCSAClassRemovedEvent removedClass  ! !

!CSAMethodCollectionMetric methodsFor: 'method events' stamp: 'f.z 1/9/2012 17:15:56.267'!
removedMethod: aCSAMethodRemovedEvent
	self remove: aCSAMethodRemovedEvent method! !

!CSAMethodCollectionMetric methodsFor: 'class events' stamp: 'f.z 1/9/2012 17:35:42.489'!
renamedClass: aClassRenamedEvent
	self triggerChange! !

!CSAMethodCollectionMetric methodsFor: 'metric computation' stamp: 'sk 1/6/2012 19:32:18.155'!
shallContain: aCompiledMethod
	self subclassResponsibility! !

!CSAMethodCollectionMetric methodsFor: 'metric computation' stamp: 'f.z 1/9/2012 17:52:25.354'!
testAndAdd: aCompiledMethod
	| debug |
	(self shallContain: aCompiledMethod) ifFalse: [ ^self ].
	debug := self buildStableRepresentationOf: aCompiledMethod.
	self methods add: (debug).
	self triggerChange! !

!CSAMethodCollectionMetric methodsFor: 'metric computation' stamp: 'sk 1/6/2012 21:35:35.557'!
testAndAddAllMethodsOf: aClass
	self
		testAndAddAllOf: aClass theNonMetaClass methodDict;
		testAndAddAllOf: aClass theMetaClass methodDict! !

!CSAMethodCollectionMetric methodsFor: 'metric computation' stamp: 'sk 1/6/2012 21:31:32.573'!
testAndAddAllOf: aMethodDictionary
	aMethodDictionary valuesDo: [ :method | self testAndAdd: method ].! !

CSAMethodCollectionMetric subclass: #CSAMethodCycloMetric
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics'!

!CSAMethodCycloMetric class methodsFor: 'as yet unclassified' stamp: 'ck 1/9/2012 16:06:01.416'!
highCyclo 
	^ 5! !

!CSAMethodCycloMetric methodsFor: 'as yet unclassified' stamp: 'ck 1/9/2012 16:05:49.678'!
shallContain: aCompiledMethod
	^ SLMethodMetricsPlugIn new methodCYCLO: 
		(SLMethodTestObject newFrom: aCompiledMethod) > self class highCyclo! !

CSAMethodCollectionMetric subclass: #CSATooLongLinesMetric
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics'!

!CSATooLongLinesMetric methodsFor: 'metric computation' stamp: 'sk 1/6/2012 19:32:59.104'!
shallContain: aCompiledMethod
	^ (SLSwaMetricsPlugIn new methodHasFormattingProblems:   
		(SLMethodTestObject newFrom: aCompiledMethod)) isPositive! !

CSAMethodCollectionMetric subclass: #CSAUnclassifiedMethodsMetric
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics'!

!CSAUnclassifiedMethodsMetric methodsFor: 'as yet unclassified' stamp: 'sk 1/6/2012 20:09:27.572'!
shallContain: aCompiledMethod
	^ (aCompiledMethod methodClass organization categoryOfElement: 
		aCompiledMethod selector) = Categorizer default  ! !

CSAMethodCollectionMetric subclass: #CSAUsedClassNamesMetric
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics'!

!CSAUsedClassNamesMetric methodsFor: 'as yet unclassified' stamp: 'sk 1/9/2012 16:54:38.771'!
shallContain: aCompiledMethod
	| literals |
	literals := aCompiledMethod literals.
	^ (literals copyWithout: literals last) contains: 
		[ :literal | literal isSymbol not and: 
			[ (literal value = aCompiledMethod methodClass) not ] ]! !

CSAMetric subclass: #CSAMethodsPerClassMetric
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics'!

!CSAMethodsPerClassMetric class methodsFor: 'accessing' stamp: 'f.z 1/9/2012 17:21:17.417'!
columnTitle
	^ 'MPC'! !

!CSAMethodsPerClassMetric class methodsFor: 'dependencies' stamp: 'sk 12/22/2011 20:58:16.14'!
requiredMetrics
	^ { CSANumberOfMethodsMetric . CSANumberOfClassesMetric}! !

!CSAMethodsPerClassMetric methodsFor: 'accessing' stamp: 'f.z 1/9/2012 17:22:03.193'!
columnContents
	^ self methodsPerClass asFloat roundTo: 0.01! !

!CSAMethodsPerClassMetric methodsFor: 'initialize-release' stamp: 'sk 12/22/2011 20:55:27.974'!
initializeFrom: aCSAClassSource  ! !

!CSAMethodsPerClassMetric methodsFor: 'accessing' stamp: 'sk 12/22/2011 20:56:25.635'!
methodsPerClass
	^ self nomMetric methodCount / self nocMetric classCount! !

!CSAMethodsPerClassMetric methodsFor: 'accessing' stamp: 'sk 12/22/2011 20:40:33.202'!
nocMetric
	^ self sourceMetrics at: CSANumberOfClassesMetric ! !

!CSAMethodsPerClassMetric methodsFor: 'accessing' stamp: 'sk 12/22/2011 20:40:51.978'!
nomMetric
	^ self sourceMetrics at: CSANumberOfMethodsMetric ! !

!CSAMetric class methodsFor: 'accessing' stamp: 'f.z 1/9/2012 16:44:27.401'!
columnTitle
	self subclassResponsibility! !

!CSAMetric class methodsFor: 'instance creation' stamp: 'sk 12/22/2011 18:40:09.996'!
for: aCSAClassSource
	^ self for: aCSAClassSource withSourceMetrics: Dictionary new! !

!CSAMetric class methodsFor: 'instance creation' stamp: 'f.z 1/9/2012 16:34:06.937'!
for: aCSAClassSource withSourceMetrics: aDictionary
	"We could do a sanity check at this point"
	^ self new
		sourceMetrics: aDictionary;  
		classSource: aCSAClassSource;
		yourself! !

!CSAMetric class methodsFor: 'dependencies' stamp: 'sk 12/22/2011 19:17:02.093'!
requiredMetrics
	^ {}! !

!CSAMetric methodsFor: 'accessing' stamp: 'sk 12/22/2011 18:30:18.809'!
classSource
	^ classSource! !

!CSAMetric methodsFor: 'accessing' stamp: 'sk 12/22/2011 19:18:00.488'!
classSource: aCSAClassSource
	classSource := aCSAClassSource.
	self initializeFrom: classSource  
! !

!CSAMetric methodsFor: 'accessing' stamp: 'f.z 1/9/2012 16:43:56.393'!
columnContents
	self subclassResponsibility! !

!CSAMetric methodsFor: 'accessing' stamp: 'f.z 1/9/2012 17:39:44.521'!
columnTitle
	self class columnTitle! !

!CSAMetric methodsFor: 'initialize-release' stamp: 'f.z 1/9/2012 16:33:15.721'!
dismiss
	^ self! !

!CSAMetric methodsFor: 'general handling' stamp: 'sk 12/22/2011 11:43:00.049'!
doDefaultHandlingFor: aCSAEvent
"Default handling is ignoring an event."! !

!CSAMetric methodsFor: 'general handling' stamp: 'f.z 1/9/2012 16:38:27.529'!
handle: aCSAEvent
	aCSAEvent accept: self! !

!CSAMetric methodsFor: 'initialize-release' stamp: 'f.z 1/9/2012 17:39:21.593'!
initialize
	super initialize.
	^ self
		initializeState;
		yourself! !

!CSAMetric methodsFor: 'initialize-release' stamp: 'f.z 12/5/2011 16:16:03.751'!
initializeFrom: aClassSource
	self subclassResponsibility  ! !

!CSAMetric methodsFor: 'initialize-release' stamp: 'sk 12/22/2011 18:32:32.35'!
initializeState 
	self sourceMetrics: Dictionary new.! !

!CSAMetric methodsFor: 'accessing' stamp: 'sk 12/22/2011 18:33:04.461'!
sourceMetrics
	^ sourceMetrics! !

!CSAMetric methodsFor: 'accessing' stamp: 'sk 12/22/2011 18:33:05.295'!
sourceMetrics: aDictionary
	sourceMetrics := aDictionary! !

!CSAMetric methodsFor: 'updating' stamp: 'f.z 1/9/2012 17:34:43.097'!
triggerChange
	self triggerEvent: #valueChanged with: self! !

CSAMetric subclass: #CSANumberOfClassesMetric
	instanceVariableNames: 'classCount'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics'!

!CSANumberOfClassesMetric class methodsFor: 'accessing' stamp: 'f.z 1/9/2012 17:23:09.482'!
columnTitle
	^ 'NOC'! !

!CSANumberOfClassesMetric methodsFor: 'class events' stamp: 'sk 12/22/2011 13:14:40.178'!
addedClass: aCSAClassAddedEvent
	self classCount: self classCount + 1! !

!CSANumberOfClassesMetric methodsFor: 'accessing' stamp: 'sk 12/22/2011 13:13:07.772'!
classCount
	^ classCount! !

!CSANumberOfClassesMetric methodsFor: 'accessing' stamp: 'f.z 1/9/2012 17:35:46.233'!
classCount: anInteger
	classCount := anInteger.
	self triggerChange
! !

!CSANumberOfClassesMetric methodsFor: 'accessing' stamp: 'f.z 1/9/2012 17:23:34.649'!
columnContents
	^ self classCount! !

!CSANumberOfClassesMetric methodsFor: 'initialize-release' stamp: 'sk 12/22/2011 13:12:51.452'!
initialize
	super initialize.
	self classCount: 0.! !

!CSANumberOfClassesMetric methodsFor: 'initialize-release' stamp: 'f.z 1/5/2012 12:46:19.44'!
initializeFrom: aCSAClassSource
	self classCount: aCSAClassSource allClasses size    ! !

!CSANumberOfClassesMetric methodsFor: 'class events' stamp: 'sk 12/22/2011 13:15:14.415'!
removedClass: aCSAClassRemovedEvent
	self classCount: self classCount - 1! !

CSAMetric subclass: #CSANumberOfMethodsMetric
	instanceVariableNames: 'methodCount'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics'!

!CSANumberOfMethodsMetric class methodsFor: 'accessing' stamp: 'f.z 1/9/2012 17:25:03.865'!
columnTitle
	^ 'NOM'! !

!CSANumberOfMethodsMetric methodsFor: 'class events' stamp: 'sk 12/22/2011 19:05:35.416'!
addedClass: aCSAClassAddedEvent
	self increaseMethodCountBy: aCSAClassAddedEvent newClass methodDict size  ! !

!CSANumberOfMethodsMetric methodsFor: 'method events' stamp: 'sk 12/22/2011 14:44:36.972'!
addedMethod: aCSAMethodAddedEvent
	self increaseMethodCountBy: 1! !

!CSANumberOfMethodsMetric methodsFor: 'accessing' stamp: 'f.z 1/9/2012 17:25:28.233'!
columnContents
	^ self methodCount  ! !

!CSANumberOfMethodsMetric methodsFor: 'accessing' stamp: 'sk 12/22/2011 14:43:05.571'!
decreaseMethodCountBy: anInteger
	self increaseMethodCountBy: anInteger negated  ! !

!CSANumberOfMethodsMetric methodsFor: 'accessing' stamp: 'sk 12/22/2011 14:41:18.518'!
increaseMethodCountBy: anInteger
	self methodCount: self methodCount + anInteger! !

!CSANumberOfMethodsMetric methodsFor: 'initialize-release' stamp: 'sk 12/22/2011 14:35:17.6'!
initialize
	super initialize.
	self methodCount: 0.! !

!CSANumberOfMethodsMetric methodsFor: 'initialize-release' stamp: 'f.z 1/5/2012 12:46:24.128'!
initializeFrom: aCSAClassSource
	self methodCount:
		(aCSAClassSource allClasses
			inject: 0
			into: [ :sum :class | sum + class methodDict size ]  )! !

!CSANumberOfMethodsMetric methodsFor: 'accessing' stamp: 'sk 12/22/2011 14:33:59.378'!
methodCount
	^ methodCount! !

!CSANumberOfMethodsMetric methodsFor: 'accessing' stamp: 'f.z 1/9/2012 17:35:51.561'!
methodCount: anInteger
	methodCount := anInteger.
	self triggerChange
! !

!CSANumberOfMethodsMetric methodsFor: 'class events' stamp: 'sk 12/22/2011 21:59:20.527'!
removedClass: aCSARemovedClassEvent
	self decreaseMethodCountBy: aCSARemovedClassEvent removedClass methodDict size  ! !

!CSANumberOfMethodsMetric methodsFor: 'method events' stamp: 'sk 12/22/2011 21:57:20.898'!
removedMethod: aCSAMethodRemovedEvent
	self decreaseMethodCountBy: 1! !

CSAMetric subclass: #CSAPerMethodMetric
	instanceVariableNames: 'entries'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics'!

CSAPerMethodMetric subclass: #CSACINTMetric
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics'!

!CSACINTMetric methodsFor: 'as yet unclassified' stamp: 'sk 1/9/2012 19:03:30.768'!
updateWith: aCompiledMethod
	self at: aCompiledMethod put:
		(SLMiscPlugIn new calledOperations: (SLMethodTestObject newFrom: aCompiledMethod))
			itemCount
	! !

CSAPerMethodMetric subclass: #CSAMethodNesting
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics'!

!CSAMethodNesting class methodsFor: 'as yet unclassified' stamp: 'ck 1/9/2012 16:02:10.48'!
highNesting 
	^ 5! !

!CSAMethodNesting methodsFor: 'as yet unclassified' stamp: 'sk 1/9/2012 17:49:12.616'!
updateWith: aCompiledMethod
	self at: aCompiledMethod put:
		(SLMethodMetricsPlugIn new maxNesting: 
			(SLMethodTestObject newFrom: aCompiledMethod)) result! !

!CSAPerMethodMetric class methodsFor: 'as yet unclassified' stamp: 'ck 12/31/2011 10:55:30.411'!
label
	self subclassResponsibility ! !

!CSAPerMethodMetric methodsFor: 'class events' stamp: 'ck 12/31/2011 10:50:54.449'!
addedClass: aClassAddedEvent
	self introduceClass: aClassAddedEvent newClass! !

!CSAPerMethodMetric methodsFor: 'method events' stamp: 'ck 12/31/2011 10:51:03.755'!
addedMethod: aMethodEvent  
	self updateWith: aMethodEvent method! !

!CSAPerMethodMetric methodsFor: 'accessing' stamp: 'sk 1/9/2012 18:10:26.83'!
at: aCompiledMethod put: aValue
	| newEntry |
	newEntry := CSAPerMethodEntry for: aCompiledMethod with: aValue.
	self entries
		removeAllSuchThat: [ :entry | entry forSameMethodAs: newEntry ];
		add: newEntry! !

!CSAPerMethodMetric methodsFor: 'user interface' stamp: 'ck 1/5/2012 17:19:32.676'!
averageDescription
	"self subclassResponsibility "! !

!CSAPerMethodMetric methodsFor: 'user interface' stamp: 'sk 1/9/2012 17:51:11.361'!
createWindow
	^ CSATextWindow 
		labelled: 'per method'
		withColor: Color green muchDarker! !

!CSAPerMethodMetric methodsFor: 'accessing' stamp: 'sk 1/9/2012 17:33:33.779'!
entries 
	^ entries ! !

!CSAPerMethodMetric methodsFor: 'accessing' stamp: 'sk 1/9/2012 17:59:01.32'!
entries: aSortedCollection
	entries := aSortedCollection ! !

!CSAPerMethodMetric methodsFor: 'accessing' stamp: 'sk 1/9/2012 18:00:20.059'!
highest
	^ self entries last! !

!CSAPerMethodMetric methodsFor: 'initialize-release' stamp: 'f.z 1/5/2012 12:45:59.088'!
initializeFrom: aCSAClassSource  
	aCSAClassSource allClasses do: [ :class | self introduceClass: class ]  ! !

!CSAPerMethodMetric methodsFor: 'initialize-release' stamp: 'sk 1/9/2012 17:59:08.929'!
initializeState
	super initializeState.
	self entries: SortedCollection new! !

!CSAPerMethodMetric methodsFor: 'metric computation' stamp: 'ck 1/5/2012 18:27:54.152'!
introduceClass: aClass
	aClass methodsDo: [:method | self updateWith: method ]! !

!CSAPerMethodMetric methodsFor: 'accessing' stamp: 'sk 1/9/2012 18:00:13.221'!
lowest
	^ self entries first! !

!CSAPerMethodMetric methodsFor: 'method events' stamp: 'ck 12/31/2011 10:51:36.839'!
modifiedMethod: aMethodEvent  
	self updateWith: aMethodEvent method! !

!CSAPerMethodMetric methodsFor: 'class events' stamp: 'sk 1/9/2012 17:33:33.839'!
removedClass: aClassRemovedEvent
	self entries removeAllSuchThat: [:item | item key = aClassRemovedEvent removedClass].  ! !

!CSAPerMethodMetric methodsFor: 'method events' stamp: 'sk 1/9/2012 17:33:33.827'!
removedMethod: aMethodEvent  
	| method|
	method := aMethodEvent method.
	self entries removeAllSuchThat: 
		[:item | item key = method methodClass and: [ item value key = method selector]] .! !

!CSAPerMethodMetric methodsFor: 'class events' stamp: 'ck 1/5/2012 18:31:13.624'!
renamedClass: aClassRenamedEvent
	| |
	self removeClass aClassRenamedEvent oldClass.
	self addedClass: aClassRenamedEvent newClass! !

!CSAPerMethodMetric methodsFor: 'user interface' stamp: 'sk 1/9/2012 17:51:48.939'!
updateWindow
	self window text:
		'hallo', String cr,
		'Worst: ', self highest , String cr,
		'Average: ', self lowest, String cr",
		'Tendency: ', self tendencyDescription."! !

!CSAPerMethodMetric methodsFor: 'metric computation' stamp: 'ck 12/31/2011 10:47:43.533'!
updateWith: aCompiledMethod
	self subclassResponsibility   ! !

!CSAPerMethodMetric methodsFor: 'user interface' stamp: 'ck 1/5/2012 17:19:41.482'!
worstCaseDescription
	"self subclassResponsibility "! !

CSAMetric subclass: #CSAWeightedMethodCount
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics'!

!CSAWeightedMethodCount class methodsFor: 'accessing' stamp: 'f.z 1/9/2012 17:26:39.065'!
columnTitle
	^ 'Weighted of methods'! !

!CSAWeightedMethodCount class methodsFor: 'dependencies' stamp: 'ck 1/6/2012 22:23:51.035'!
requiredMetrics
	^ {CSAMethodCycloMetric}! !

!CSAWeightedMethodCount methodsFor: 'as yet unclassified' stamp: 'sk 1/9/2012 17:33:33.811'!
calculateWeights
	|weights|
	weights := Dictionary new.
	self methodCycloMetric entries do: 
		[:tuple | | weight | 
			weight := weights at: (tuple key) 
				ifAbsent: [weight := weights at: (tuple key) put: 0].
			weights at: (tuple key) put: (weight value + tuple value value)].
	^ weights ! !

!CSAWeightedMethodCount methodsFor: 'accessing' stamp: 'f.z 1/9/2012 17:30:06.685'!
columnContents
	| weight |
	weight := self highestMethodWeight.
	^ weight key, ' >> ', weight value! !

!CSAWeightedMethodCount methodsFor: 'metric computation' stamp: 'f.z 1/9/2012 17:30:06.641'!
highestMethodWeight
	| weights |
	weights := self calculateWeights.
	weights :=weights associations sorted: [:first :second | first value <= second value].
	^ weights last.! !

!CSAWeightedMethodCount methodsFor: 'initialize-release' stamp: 'f.z 1/9/2012 17:27:44.825'!
initializeFrom: aClassSource
	^ self! !

!CSAWeightedMethodCount methodsFor: 'dependencies' stamp: 'ck 1/6/2012 22:24:50.799'!
methodCycloMetric
	^ self sourceMetrics at: CSAMethodCycloMetric ! !

Object subclass: #CSAPerMethodEntry
	instanceVariableNames: 'methodClass selector metricValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics'!

!CSAPerMethodEntry class methodsFor: 'as yet unclassified' stamp: 'sk 1/9/2012 18:06:28.575'!
for: aCompiledMethod with: aValue
	^ self new
		methodClass: aCompiledMethod methodClass;
		selector: aCompiledMethod selector;
		metricValue: aValue;
		yourself.! !

!CSAPerMethodEntry methodsFor: 'accessing' stamp: 'sk 1/9/2012 17:58:37.54'!
<= aCSAPerMethodEntry
	^ self metricValue <= aCSAPerMethodEntry metricValue  ! !

!CSAPerMethodEntry methodsFor: 'accessing' stamp: 'sk 1/9/2012 18:32:06.391'!
asString
	^ self methodClass asString, '>>', self selector asString, ': ', self metricValue asString  ! !

!CSAPerMethodEntry methodsFor: 'accessing' stamp: 'sk 1/9/2012 18:03:16.214'!
forSameMethodAs: aCSAPerMethodEntry
	^ self methodClass = aCSAPerMethodEntry methodClass
		and: [ self selector = aCSAPerMethodEntry selector ]  ! !

!CSAPerMethodEntry methodsFor: 'accessing' stamp: 'sk 1/9/2012 17:58:00.271'!
methodClass
	^ methodClass! !

!CSAPerMethodEntry methodsFor: 'accessing' stamp: 'sk 1/9/2012 17:58:00.343'!
methodClass: aClass
	methodClass := aClass
! !

!CSAPerMethodEntry methodsFor: 'accessing' stamp: 'sk 1/9/2012 17:58:00.434'!
metricValue
	^ metricValue! !

!CSAPerMethodEntry methodsFor: 'accessing' stamp: 'sk 1/9/2012 17:58:00.465'!
metricValue: anObject
	metricValue := anObject! !

!CSAPerMethodEntry methodsFor: 'accessing' stamp: 'sk 1/9/2012 17:58:00.372'!
selector
	^ selector! !

!CSAPerMethodEntry methodsFor: 'accessing' stamp: 'sk 1/9/2012 17:58:00.403'!
selector: aSymbol
	selector := aSymbol
! !
